--feist NFL spreads 2003
global constant WEEK_PATH="c:\\euph_nfl03\\alldata.dat"
--	global constant TEAM_PATH="C:\\progra~1\\liberty"
--global constant STATS_PATH="c:\\progra~1\\liberty\\NFL"
--global constant AMAIN_WEEK_PATH="amain.dat"

include get.e
include file.e
include mydate.e
include font.e
include mygets.e
include myfile.e
--include teams.e
include scroll.e
include all.e

sequence week,week_data

--week="2"
week_data=get_amain_week()
week=week_data[1]
constant INPUT_PATH="c:\\windows\\"
constant INPUT_FILE= "feist"&week&".txt"      
constant OUTPUT_PATH="c:\\progra~1\\liberty\\football\\"
constant OUTPUT_PATH2="c:\\progra~1\\liberty\\NFL03\\spread"&week&".dat"
constant OUTPUT_FILE="trade.dat"

sequence generated_date,myfile,gamedate,hometeam,visteam,home_spread,vis_spread,gdate,
         mydir,spread,ou,myfile1,mydir1,mytime,rotation,feist_db,myday,gameday
object fn,line,fn2,fn3
integer game,knockoff,upper_limit,answer
atom visdec,homedec

  function get_generated_date()
   sequence stamp,line
   integer a
    while 1=1 do
     line=gets(fn)
     if match("/2003",line) then 
       exit
     end if
    end while
   a=match(" at ",line)
   stamp=line[a+4..length(line)]
   return stamp
  end function

  function clean_team(sequence team)
    integer i
    i=find(team[1..3],FEIST_CODE)
    if i > 0 then
      team=MYTEAMS2[i]
    elsif not compare("NY",team[1..2]) then
       team=team[1..2]&team[4..4]
       i=find(team,FEIST_CODE)
       team=MYTEAMS2[i]
    end if
   return team
  end function

  function clean_spread(sequence spread)
   sequence feist,nasa
   integer a
      feist=spread
     a=match("-",spread)
       if a >0 then 
        spread=trim(spread[1..a-1])
       end if
      a=match(" ",spread)
  if a >0 then
      feist=spread[1..a-1]
      nasa=trim(spread[a..length(spread)])
      feist=clean_half(feist)
   else
      if length(feist) > 0 then
        feist=clean_half(spread)
      end if
   end if
  return feist
  end function

 function clean_time(sequence mytime)
   mytime=trim(mytime)
   mytime=mytime[1..length(mytime)-1]
  return mytime
 end function

procedure print_heading(integer fn)
-------------------open the file to read----------------
       printf(fn,"For Week %s of Football 2003\n",week)
       printf(fn,"%s %s Generated: %s",{mydir1 , myfile1,generated_date})
end procedure

function feist(integer work)
--work codes:0=read only   1=read and print  2=read and save
  text_color(WHITE)
-------------------open the file to read----------------
  mydir1=INPUT_PATH
  myfile1=INPUT_FILE
  fn=my_open(mydir1&myfile1,"r")
  generated_date=get_generated_date()
  --puts(1,generated_date)
 --------------------open the file to write---------------------
  mydir=OUTPUT_PATH
  myfile=OUTPUT_FILE
    if work=2 then
       fn2=my_open(mydir&myfile,"w")
       fn3=my_open(OUTPUT_PATH2,"w")
--?fn3
--abort(0)
       print_heading(fn2)
       print_heading(fn3)
     --  printf(fn2,"For Week %d of Football 2003\n",99)
    --  printf(fn2,"%s %s Generated: %s",{mydir1 , myfile1,generated_date})
      -- printf(fn3,"For Week %d of Football 2003\n",99)
     -- printf(fn3,"%s %s Generated: %s",{mydir1 , myfile1,generated_date})
   elsif work=1 then
      print_heading(1)
   end if
 ----------------first pass read the text file-----------------
   feist_db={}
   game=0
   knockoff=0
   gdate=repeat({},50)
   mytime=repeat({},50)
   myday=repeat({},50)
   visteam=repeat({},50)
   hometeam=repeat({},50)
   rotation=repeat({},50)
   vis_spread=repeat({},50)
   home_spread=repeat({},50)

   while 1=1 do
          line=gets(fn)
          if atom(line) then
             exit
          end if
             if match("/2003",line) then
                gamedate=clean_date(trim(line))


                gameday=get_day(gamedate)
             end if
         if match(":",line) then
            game=game+1 
            gdate[game]=trim(gamedate)  
            mytime[game]=clean_time(line)
            myday[game]=trim(gameday)
            line=gets(fn)--a rotation
               rotation[game]=trim(line)
            line=gets(fn)--a rotation
            line=gets(fn)
              visteam[game]=trim(line)
            line=gets(fn)
              hometeam[game]=trim(line)
            line=gets(fn)--a space
            line=gets(fn)--a space
            line=gets(fn)
              vis_spread[game]=trim(line)
            line=gets(fn)
              home_spread[game]=trim(line)
         end if
   end while
   -------------------------pass 2 clean items--------------
      for x= 1 to game do
          visteam[x]=clean_team(visteam[x])
          hometeam[x]=upper(clean_team(hometeam[x]))
          vis_spread[x]=clean_spread(vis_spread[x])
          home_spread[x]=clean_spread(home_spread[x])
     --=    printf(1,"%d %s %s %s >%s< >%s<\n",
          --     {x,gdate[x],visteam[x],hometeam[x],vis_spread[x],home_spread[x]})
      end for
  -------------------------pass 2A throw out duplic+tes--------------------
       for x=1 to game do
           if not compare(rotation[x],rotation[x+1]) then
           --  printf(1,"prior to change %d %s %s\n",{x,rotation[x],vis_spread[x]})
          --   printf(1,"prior to change %d %s %s\n\n",{x+1,rotation[x+1],vis_spread[x+1]})
               rotation[x]="****"
              for y=x to game do
                 gdate[y]=gdate[y+1]
                 myday[y]=myday[y+1]
                 mytime[y]=mytime[y+1]
                 rotation[y]=rotation[y+1]
                 visteam[y]=visteam[y+1]
                 hometeam[y]=hometeam[y+1]
                 vis_spread[y]=vis_spread[y+1]
                 home_spread[y]=home_spread[y+1]
              end for   
            knockoff=knockoff+1    
        --     printf(1,"   after change %d %s %s\n",{x,rotation[x],vis_spread[x]})
         --    printf(1,"   after change %d %s %s\n",{x+1,rotation[x+1],vis_spread[x+1]}) 
           end if
         --myday[x]="---"
       end for
-- pause()
   ------------------------pass 3 figure fav and print out-----------\
      upper_limit=game-knockoff
     if upper_limit>16 then
         upper_limit=16
     end if
       for x=1 to upper_limit  do
          visdec=getdec(vis_spread[x])
          homedec=getdec(home_spread[x])
          if visdec = 0 and homedec = 0 then
                 if match("PK",vis_spread[x]) then
                     fav=visteam[x]
                     dog=hometeam[x]
                     spread=vis_spread[x]
                     ou=home_spread[x]
                 else  -- i don't think need the home "PK" question
                     fav=hometeam[x]
                     dog=visteam[x]
                     spread=home_spread[x]
                     ou=vis_spread[x]  
                end if
          elsif visdec = 0 and homedec > 0 then
                if match("PK",vis_spread[x]) and homedec > 30 then
                     fav=visteam[x]
                     dog=hometeam[x]
                     spread=vis_spread[x]
                     ou=home_spread[x]
                else 
                   fav=hometeam[x]
                   dog=visteam[x]
                   spread=home_spread[x]
                   ou=vis_spread[x]
                end if
          elsif visdec > 0 and homedec = 0 then
                 if match("PK",home_spread[x]) and visdec > 30 then
                   fav=hometeam[x]
                   dog=visteam[x]
                   spread=home_spread[x]
                   ou=vis_spread[x]
                 else
                    fav=visteam[x]
                    dog=hometeam[x]
                    spread=vis_spread[x]
                    ou=home_spread[x]
                 end if
          elsif visdec > 0 and homedec > 0 then
                  if visdec > homedec then 
                     fav=hometeam[x]
                     dog=visteam[x]
                     spread=home_spread[x]
                     ou=vis_spread[x]
                  elsif visdec < homedec then
                     fav=visteam[x]
                     dog=hometeam[x]
                     spread=vis_spread[x]
                     ou=home_spread[x]
                  end if
          end if
              feist_db=append(feist_db,sprintf("%d,%s,%s,%s,%s,%s,%s,%s,",
               {x,gdate[x],myday[x],mytime[x],trim(fav),spread,ou,trim(dog)}))
                if work=1 then
                    printf(1,"%d,%s,%s,%s,%s,%s,%s,%s,\n",
                   {x,gdate[x],myday[x],mytime[x],trim(fav),spread,ou,trim(dog)})
                end if
               if work=2 then
                   printf(fn2,"%d,%s,%s,%s,%s,%s,%s,%s,\n",
                   {x,gdate[x],myday[x],mytime[x],trim(fav),spread,ou,trim(dog)})
                   printf(fn3,"%d,%s,%s,%s,%s,%s,%s,%s,\n",
                   {x,gdate[x],myday[x],mytime[x],trim(fav),spread,ou,trim(dog)})
               end if
       end for
   if work=2 then
     close(fn2)
     close(fn3)
   end if
  close(fn)
 return feist_db
end function

procedure update_db(integer fn,sequence old_db,sequence new_db)
  sequence old_fav_test,new_fav_test,new_dog_test
  object a,b
    old_fav_test={}  
    new_fav_test={}
    new_dog_test={}  
   for x= 1 to length(old_db) do --setup test array for old_db
       printf(1,"old_db=%d %s\n",{x,old_db[x][1]})
      line=split(old_db[x],',')
      old_fav_test=append(old_fav_test,trim(line[2])&trim(line[4])&trim(line[5]))
   end for
     for x=1 to length(new_db) do --setup test array for new_db
        line=split(new_db[x],',')
        new_fav_test=append(new_fav_test,trim(line[2])&trim(line[4])&trim(line[5]))
        new_dog_test=append(new_dog_test,trim(line[2])&trim(line[4])&trim(line[8]))
    end for
    for x= 1 to length(old_db) do
   --  puts(1,">"&old_fav_test[x]&"<     >"&new_fav_test[x]&"<   >"&new_dog_test[x]&"<\n") 
        a=find(old_fav_test[x],new_fav_test)
        b=find(old_fav_test[x],new_dog_test)
         if a=0 and b=0 then  --not found 
             line=split(old_db[x],',')
             line[1]="*"&trim(line[1])
             old_db[x]=reconstruct_line(line)
             puts(fn,old_db[x]&"\n")
         elsif a>0 then --found still the fav
             line=split(old_db[x],',')
             line[1]=sprintf("%3d",x)
             new_db[a]=reconstruct_line(line)--keep the old numbers
             puts(fn,new_db[a]&"\n")
         elsif b>0 then --found fav/dog switched
             line=split(old_db[x],',')
             line[1]=sprintf("%3d",x)
             new_db[b]=reconstruct_line(line)--keep the old numbers
             puts(fn,new_db[b]&"**************\n")
         -- puts(1,old_fav_test[x]&"    "&new_fav_test[x]&"\n") 
         end if
    end for
end procedure
-------------------real start of main program----------------------
------------------------------------------------------------------------------------

                           --start--

------------------------------------------------------------------------------------
global procedure feist_main()
    sequence old_db,new_db
    integer a
    clear_screen()
    bk_color(RED)
     new_db=feist(1)--read and print
      answer= overwrite_warning(OUTPUT_PATH2)
if answer=1 then --normal
   new_db=feist(2)--save
elsif answer=3 then--update
     old_db=read_all("spread")
     old_db=old_db[1]
     new_db=feist(1)--read and print only
      puts(1,"\n>>>>>>>>>>\n")
         print_heading(1)
         update_db(1,old_db,new_db)
      puts(1,"  [Return] to Save]     [Esc] to Go Back]")
     while 1=1 do
      a=wait_key() 
       if a=27 then 
              exit
       elsif a=13 then 
       mydir=OUTPUT_PATH
       myfile=OUTPUT_FILE
       fn2=my_open(mydir&myfile,"w")
       fn3=my_open(OUTPUT_PATH2,"w")
        print_heading(fn2)
        print_heading(fn3)
              update_db(fn2,old_db,new_db)
              update_db(fn3,old_db,new_db)
         close(fn2)
         close(fn3)
         exit
       end if
      end while
elsif answer=2 then--do nothing
end if
end procedure--feist_main()