--more dates by don cole 2004
include get.e

 global constant LEAPYEAR = {"00","04","08","12","16","20","24","28"}
 global constant DAY={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"}
 global constant LONGDAY={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"}
 global constant LONGMONTH = {"January","February","March","April","May","June","July",
                              "August","September","October","November","December"}
 global sequence DAYS_IN_MONTH  DAYS_IN_MONTH={31,28,31,30,31,31,31,31,30,31,30,31}

global function find_last_chr(sequence chr,sequence string)
 integer a,b
  b=0
  a=match(chr,string)
   if a = 0 then
     b=a
   elsif a > 0 then
      while 1=1 do
       b=b+a
        a=match(chr,string[b+1..length(string)])
          if a = 0 then
            exit
          end if
      end while
   end if
 return b
end function

global function getdec(sequence seq) --returns a decimal given a sequence
atom de
sequence value_string
  value_string=value(seq)
 de = value_string[2]
return de
end function

global function getdate()--returns the date in 00/00/00 form
   sequence now,md
   now = date()
   md=sprintf("%02d/%02d/%02d\n",{now[2],now[3],now[1]-100})
   md=md[1..length(md)-1]
  return md
end function

global function getdaynum()--returns the date day
   sequence now
   now=date()
   return now[3]
end function

global function getday()
  sequence now,md--return a this weekday string
  now=date()
  md=sprintf("%s\n",{DAY[now[7]]})
  md=md[1..length(md)-1]
  return md
end function

global function getdays_past()--for year
  sequence now
  now=date()
  return now[8]
end function

global function gettime()--returns time in 00:00:00 form
  sequence tm,now
  now=date()
  tm=sprintf("%02d:%02d:%02d",{now[4],now[5],now[6]})
  return tm
end function

global function parse_time(sequence mytime)--a time sent in form 00:00:00
  sequence hr,min,sec
  integer a,b
  a=match(":",mytime)
  b=match(":",mytime[a+1..length(mytime)])+a
    if a<1 or b<1 then
      printf(1,"illegal time >%s< a=%d",{mytime,a})
    end if
  hr=mytime[1..a-1]
  min=mytime[a+1..b-1]
  sec=mytime[b+1..length(mytime)]
  return  {hr} & {min} & {sec}
end function

global function get_years()
       sequence years
        years={}
        for x=1 to 7 do --build years sequence
         years=append(years,x+1996) 
        end for
  return years
end function

global function clean_date(sequence adate)--converts 00/00/2004 to 00/00/04
 sequence mydate,pre,post
 integer a,b
      a=match("/",adate)
      b=match("/",adate[a+1..length(adate)])
      pre=adate[1..a+b]
      post=adate[length(adate)-1..length(adate)]
      mydate=pre&post
 return mydate
end function

global function parse_date(sequence mydate)--adate sent in form 00/00/00
  sequence myday,mymonth,myyear
  integer a,b
  a=match("/",mydate)
  b=match("/",mydate[a+1..length(mydate)])+a
    if a<1 or b<1 then
      printf(1,"illegal date >%s< a=%d",{mydate,a})
    end if
  mymonth=mydate[1..a-1]
  myday=mydate[a+1..b-1]
  myyear=mydate[b+1..length(mydate)]
 -- printf(1,"day=%s month=%s yr=%s\n",{myday,mymonth,myyear})
  return  {myday} & {mymonth} & {myyear}
end function

procedure adj_days_in_month(sequence yr)
   integer a
    a=find(yr,LEAPYEAR)
        if a then
          DAYS_IN_MONTH[2]=29
        else
          DAYS_IN_MONTH[2]=28
        end if
end procedure

--1 the remaining DAYS in this month
--2 the remaining days in the remaining months of this year
--3 the middle years
--4 the days in months of the last year
--5 the days in the last month
global function get_day(sequence mydate)--returns a weekday in the future
   sequence today,unknown
   integer totdays,a
     totdays=find(getday(),DAY)
    today=parse_date(getdate())
     unknown=parse_date(mydate)
   if getdec(today[3]) > getdec(unknown[3]) then
      puts(1,mydate&" has passed")
   elsif getdec(today[3]) < getdec(unknown[3]) then
      ----------------[1] deal with the remaining DAYS of this month-------
        adj_days_in_month(today[3])
        totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
      ----------------[2] deal with rest of this year MONTHS---------------
        adj_days_in_month(today[3])
       for x=getdec(today[2])+1 to 12 do--deal with rest of this year
          totdays=totdays+DAYS_IN_MONTH[x]
       end for
      ----------------[3] deal with the middle YEARS (if nescessary)--------
       for x = getdec(today[3])+1 to getdec(unknown[3])-1 do--deal with middle years
          a=find(sprintf("%02d",x),LEAPYEAR)
            if a then
              totdays=totdays+366
            else 
              totdays=totdays+365
            end if
       end for
      ----------------[4] deal with the last months 0f the last year---------
         adj_days_in_month(unknown[3])
       for x=1 to getdec(unknown[2]) -1 do--deal with the months of the last year
           totdays=totdays+DAYS_IN_MONTH[x]
       end for
       ---------------[5] deal with the last days of the last month----
        totdays=totdays+getdec(unknown[1])
---------------------------------------------------------------------------
   elsif getdec(today[3]) = getdec(unknown[3]) then
        if getdec(today[2]) > getdec(unknown[2]) then
              puts(1,mydate&" has passed")
              abort(0)
        elsif getdec(today[2]) < getdec(unknown[2]) then
          ---------------- deal with the remaining DAYS of this month-------
            adj_days_in_month(today[3])
         totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
          ----------------deal with the months------------
             for x=getdec(today[2])+1 to getdec(unknown[2])-1 do
                totdays=totdays+DAYS_IN_MONTH[x]
             end for
          ---------------- deal with the last days of the last month----
            totdays=totdays+getdec(unknown[1])
        elsif getdec(today[2]) = getdec(unknown[2]) then
           -------------- deal with the remaining DAYS of this month-------
        totdays=totdays+getdec(unknown[1])-getdec(today[1])
        end if
   end if
     while totdays>700 do
       totdays=totdays-700
     end while
       while totdays>70 do
          totdays=totdays-70
       end while
          while totdays>7 do
             totdays=totdays-7
          end while
  return LONGDAY[totdays]
end function

 global function get_short_year(sequence mydate)
    return mydate[1..6]&mydate[9..10]
 end function

 global function get_long_year(sequence mydate)--converts 00/00/04 to 00/00/2004
   integer a
   sequence ajust
   a=find_last_chr("/",mydate)
    if a>0 then
         if length(mydate[a+1..length(mydate)])=2 then
              ajust= mydate[a+1..length(mydate)]
         elsif length(mydate[a+1..length(mydate)])=1 then
              ajust="0"&mydate[a+1..length(mydate)] 
         end if
           if getdec(ajust)<50 then
              return "20"&ajust
           else
              return "19"&ajust
           end if
    else
      return "no date found"
    end if
 end function
  
 global function getTotSecs(sequence mytime)
     integer a
     sequence min,secs
      a=match(":",mytime)
        if a>0 then
          min=mytime[1..a-1]
          secs=mytime[a+1..length(mytime)]
          return getdec(min)*60 + getdec(secs)
        else
          return getdec(mytime)*60 
        end if
 end function

 global function getMPH(sequence dist,sequence mytime)
  atom mpg
  mpg= getdec(dist)/getTotSecs(mytime)*3600
  return sprintf("%.1f",mpg)
 end function


global function getTimePassed(sequence mydate,sequence mytime)
    sequence data
    integer nSec,oSec,secs,nMin,oMin,mins,nHr,oHr,hrs,nDay,oDay,days,oMon,nMon,oYr,nYr,
            months,yrs
     data=parse_time(gettime())
         nSec=getdec(data[3])
         nMin=getdec(data[2])
         nHr= getdec(data[1])
     data=parse_date(getdate())
         nDay=getdec(data[1])
         nMon=getdec(data[2])
         nYr= getdec(data[3])
     data=parse_time(mytime)
         oSec=getdec(data[3])
         oMin=getdec(data[2])
         oHr= getdec(data[1])
     data=parse_date(mydate)
         oDay=getdec(data[1])
         oMon=getdec(data[2])
         oYr =getdec(data[3])
         if oSec > nSec then
           nSec=nSec+60
           nMin=nMin-1
         end if
       secs=nSec-oSec
             if oMin > nMin then
                nMin=nMin+60
                nHr=nHr-1
             end if
       mins=nMin-oMin
                if oHr > nHr then
                   nHr=nHr+24
                   nDay=nDay-1
                end if
       hrs=nHr-oHr
                 if oDay > nDay then
                    nDay=nDay+ DAYS_IN_MONTH[oMon+1]
                    nMon=nMon-1
                 end if
       days=nDay-oDay
                 if oMon > nMon then
                    nMon=nMon+ 12
                    nYr=nYr-1
                 end if
       months=nMon-oMon
       yrs=nYr-oYr
   return {days} & {hrs} & {mins} & {secs} & {months} & {yrs}
end function

global function get_days_passed(sequence mydate)
  sequence s
     s=getTimePassed(mydate,"00:00:00")
 return s[1]+s[5]*30
end function

global function get_countdown(sequence mydate,sequence mytime)
  integer mons,days,hrs,mins,secs,nSec,nMin,nHr,nDay,nMon,oSec,oMin,oHr,oDay,oMon,nYr,oYr,yrs
  sequence data
     data=parse_time(gettime())
     nSec=getdec(data[3])
     nMin=getdec(data[2])
     nHr=getdec(data[1])
     data=parse_date(getdate())
     nDay=getdec(data[1])
     nMon=getdec(data[2])
     nYr=getdec(data[3])
       data=parse_time(mytime)
       oSec=getdec(data[3])
       oMin=getdec(data[2])
       oHr=getdec(data[1])
       data=parse_date(mydate)
       oDay=getdec(data[1])
       oMon=getdec(data[2])
       oYr=getdec(data[3])
         if oSec < nSec then 
            oSec=oSec+60
            oMin=oMin-1
         end if
         secs=oSec-nSec
            if oMin < nMin then
               oMin = oMin + 60
               oHr=oHr-1
            end if
        mins=oMin-nMin
              if oHr < nHr then
                 oHr=oHr+24
                 oDay=oDay-1
              end if
         hrs=oHr-nHr
                  if oDay < nDay then
                     adj_days_in_month(oYr)
                     oDay=oDay+DAYS_IN_MONTH[oMon]
                     oMon=oMon-1
                  end if
         days=oDay-nDay
                  if oMon < nMon then
                     oMon=oMon+12
                     oYr=oYr-1
                  end if
         mons=oMon-nMon
         yrs=oYr-nYr
  return {mons} & {days} & {hrs} & {mins} & {secs} & {yrs}
end function

global function get_mil_to_standard(sequence mytime)
   integer a,hr
   sequence hour,min,suf
   a=match(":",mytime)
   hour=mytime[1..a-1]
   min=mytime[a+1..length(mytime)]--this is really mins And secs
   hr=getdec(hour)
   suf=" AM"
    if hr>12 then
      hr=hr-12
      suf=" PM"
    end if
      hour=sprintf("%d",hr)
 return hour&":"&min&suf
end function
