include mygets.e as MG

--2000, 2004, 2008, 2012, 2016, 2020, 2024, 2028, 2032, 2036, 2040, 2044, and 2048. 
 global constant LEAPYEAR = {"00","04","08","12","16","20","24","28"}
 global constant DAY={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"}
 global constant LONGDAY={"Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday"}
--global constant DAYS_IN_MONTH={31,28,31,31,30,31,31,31,30,31,30,31}
 global constant LONGMONTH = {"January","February","March","April","May","June","July",
                              "August","September","October","November","December"}
 global sequence DAYS_IN_MONTH  DAYS_IN_MONTH={31,28,31,30,31,31,31,31,30,31,30,31}

global function getdate()--returns date in 00/00/00 form
   sequence now,md
   now = date()
   md=sprintf("%02d/%02d/%02d\n",{now[2],now[3],now[1]-100})
   md=md[1..length(md)-1]
  return md
end function

global function getdaynum()
   sequence now
   now=date()
   return now[3]
end function

global function getday()
  sequence now,md--return a this day string
  now=date()
 -- day={"Sun","Mon","Tue","Wed","Thu","Fri","Sat"}
  md=sprintf("%s\n",{DAY[now[7]]})
  md=md[1..length(md)-1]
  return md
end function

global function getdays_past()--for year
  sequence now
  now=date()
  return now[8]
end function

global function gettime()--returns the current time in 00:00:00 form 
  sequence tm,now
  now=date()
  tm=sprintf("%02d:%02d:%02d",{now[4],now[5],now[6]})
  return tm
end function

global function getShortTime()
     sequence t
        t=gettime()
    return t[1..5]
end function

global function getyear2()  --returns current year as 2 digit seq
   sequence now
   now=date()
   return sprintf("%02d",now[1]-100)
end function

global function getYear(sequence a)  --returns short year in dec?
  sequence now
  now=date()
   if equal("str",a) then 
          return sprintf("%02d",now[1]-100)
   elsif equal("dec",a) then
       return now[1]-100
   end if 
end function

global function getLongYear()--returns dec
  sequence now
  now=date()
  return now[1]+1900
end function

global function parse_time(sequence mytime)--a time sent in form 00:00:00
  sequence hr,min,sec
  integer a,b
  a=match(":",mytime)
  b=match(":",mytime[a+1..length(mytime)])+a
    if a<1 or b<1 then
      printf(1,"illegal time >%s< a=%d\n",{mytime,a})
      mytime="00:00:00"
      a=match(":",mytime)
      b=match(":",mytime[a+1..length(mytime)])+a
    end if
  hr=mytime[1..a-1]
  min=mytime[a+1..b-1]
  sec=mytime[b+1..length(mytime)]
  return  {hr} & {min} & {sec}
end function

global function get_years()--decimal
       sequence years
        years={}
        for x=1 to 10 do --build years sequence
         years=append(years,x+1996) 
       --  printf(1,"%d\n",x+1996)
        end for
  return years
end function

global function getYears()--strings used in amain combo
    sequence years,yrs
     years={}
     yrs={}
      for x= 1 to 14 do--1=97,2=98,3=99,4=2000,5=2001,6=2002,7=2003,8=2004,9=2005,10=2006
                       --11=2007,12=2008,13=2009,14=2010**************add each year
        years=append(years,sprintf("%d",x+1996))--sequence in "2004" format
        yrs=append(yrs,years[x][3..4])             --sequence in "04" format
      end for
    return {years} & {yrs}
end function

global function getLongYears()--stroing used in amain year combo
   sequence years  years=getYears()
   return years[1]  
end function

global function getShortYears()
   sequence yrs  yrs=getYears()
   return yrs[2]
end function

global function date4to2(sequence d)--converts 00/00/2004 to 00/00/04
   sequence s
    s=match_all("/",d)
   return d[1..s[$]] & d[$-1..$]
end function

global function clean_date(sequence adate)--converts 00/00/2004 to 00/00/04
 sequence year,pre,post
 integer a
--?9/0
--    puts(1,  adate  &"\n")
      a=match("/",adate)
        --  if a= 0 then
    --       return "00/00/00"
       --   end if
        pre=adate[1..a-1]--first digit only
        pre=sprintf("%02s",pre)--add zeros if needed  
        post=adate[a+1..$]--cuts off first /   
      a=match("/",post)   
         year=post[a+1..$]--year only
         year=year[3..4]--year last 2
         post=post[1..a-1]--second digit only
         post=sprintf("%02s",post)--add zeros if necessary  
 return pre&"/"&post&"/"&year
end function

global function clean_all_dates(sequence mydate)
   integer a
   sequence mo,bal,day,yr
--  printf(1,"mydate=>%s<",{mydate})
     a=match("/",mydate)
      mo=sprintf("%03s",{mydate[1..a]})--add zero and add leave slash
--  puts(1,mo    &"\n")
      bal=mydate[a+1..$]
     a=match("/",bal)
      day=sprintf("%03s",{bal[1..a]})--add zero and add leave slash 
      bal=bal[a+1..$]
      if length(bal) > 2 then
        yr=bal[$-1..$]
      else
        yr=bal
      end if
--puts(1, mo&day&yr &"\n")
   return mo&day&yr
end function

global function parse_date(sequence mydate)--adate sent in form 00/00/00
  sequence myday,mymonth,myyear
  integer a,b
      --  if equal({},mydate) then
       --     mydate="00/00/00"
     --   end if
  a=match("/",mydate)
  b=match("/",mydate[a+1..length(mydate)])+a
    if a<1 or b<1 then
--    printf(1,"in mydate.e illegal date -->%s<-- a=%d\n",{mydate,a})
--  ?9/0
      mydate="00/00/00"
      a=match("/",mydate)
      b=match("/",mydate[a+1..length(mydate)])+a
    end if
  mymonth=mydate[1..a-1]
  myday=mydate[a+1..b-1]
  myyear=mydate[b+1..length(mydate)]
 -- printf(1,"day=%s month=%s yr=%s\n",{myday,mymonth,myyear})
  return  {myday} & {mymonth} & {myyear}
end function

global function getmonth(sequence mydate)
   sequence stuff
   stuff=parse_date(mydate)
   return stuff[2]
end function

global function getyear(sequence mydate)
     sequence stuff
       stuff=parse_date(mydate)
       return stuff[3]
end function

procedure adj_days_in_month(sequence yr)
   integer a
    a=find(yr,LEAPYEAR)
        if a then
          DAYS_IN_MONTH[2]=29
        else
          DAYS_IN_MONTH[2]=28
        end if
end procedure

--1 the remaining DAYS in this month
--2 the remaining days in the remaining months of this year
--3 the middle years
--4 the days in months of the last year
--5 the days in the last month

global function get_day2(sequence mydate)
   sequence today,unknown
   integer totdays,a
     totdays=find(getday(),DAY)
    today=parse_date(getdate())
     unknown=parse_date(mydate)
   if getdec(today[3]) > getdec(unknown[3]) then
      puts(1,mydate&" has passed")
   elsif getdec(today[3]) < getdec(unknown[3]) then
      ----------------[1] deal with the remaining DAYS of this month-------
      --  puts(1,"[1] entered\n")
        adj_days_in_month(today[3])
        totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
       -- printf(1,"This month total days=%d\n",DAYS_IN_MONTH[getdec(today[2])])
      --  printf(1," days passed=%s\n",{today[1]})
     --   printf(1," diff=%d\n",DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1]))
       -- printf(1," totdays=%d\n",totdays)
      ----------------[2] deal with rest of this year MONTHS---------------
        adj_days_in_month(today[3])
       for x=getdec(today[2])+1 to 12 do--deal with rest of this year
          totdays=totdays+DAYS_IN_MONTH[x]
       --   printf(1,"**%d %d %d\n",{x,DAYS_IN_MONTH[x],totdays})
       end for
      ----------------[3] deal with the middle YEARS (if nescessary)--------
       for x = getdec(today[3])+1 to getdec(unknown[3])-1 do--deal with middle years
          a=find(sprintf("%02d",x),LEAPYEAR)
            if a then
              totdays=totdays+366
            else 
              totdays=totdays+365
            end if
        --  printf(1,"%02d %d %d\n",{x,a,totdays})
       end for
      ----------------[4] deal with the last months 0f the last year---------
         adj_days_in_month(unknown[3])
       for x=1 to getdec(unknown[2]) -1 do--deal with the months of the last year
           totdays=totdays+DAYS_IN_MONTH[x]
         -- printf(1,"%d %d %d\n",{x,DAYS_IN_MONTH[x],totdays})
       end for
       ---------------[5] deal with the last days of the last month----
        totdays=totdays+getdec(unknown[1])
---------------------------------------------------------------------------
   elsif getdec(today[3]) = getdec(unknown[3]) then
        if getdec(today[2]) > getdec(unknown[2]) then
              puts(1,mydate&" has passed")
              abort(0)
        elsif getdec(today[2]) < getdec(unknown[2]) then
          ---------------- deal with the remaining DAYS of this month-------
            adj_days_in_month(today[3])
         totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
          ----------------deal with the months------------
             for x=getdec(today[2])+1 to getdec(unknown[2])-1 do
                totdays=totdays+DAYS_IN_MONTH[x]
             end for
          ---------------- deal with the last days of the last month----
            totdays=totdays+getdec(unknown[1])
        elsif getdec(today[2]) = getdec(unknown[2]) then
           -------------- deal with the remaining DAYS of this month-------
        totdays=totdays+getdec(unknown[1])-getdec(today[1])
        end if
   end if
     while totdays>700 do
       totdays=totdays-700
     end while
       while totdays>70 do
          totdays=totdays-70
       end while
          while totdays>7 do
             totdays=totdays-7
          end while
  return LONGDAY[totdays]
end function

 global function get_short_year(sequence mydate)
      sequence junk
        junk=parse_date(mydate)
      if length(junk[3]) >2 then
       return junk[2]&"/"&junk[1]&"/"&junk[3][3..4]
      end if
    return mydate
 end function

global function get_day(sequence mydate)--returns a weekday in the future
   sequence today,unknown
   integer totdays,a 
 -- mydate="08/06/06"
--puts(1,   mydate &"<<<<<<<<<<<<\n")
     totdays=find(getday(),DAY)
    today=parse_date(getdate())
       mydate=get_short_year(mydate)
     unknown=parse_date(mydate)
   if getdec(today[3]) > getdec(unknown[3]) then
      puts(1,mydate&" has passed")
   elsif getdec(today[3]) < getdec(unknown[3]) then
      ----------------[1] deal with the remaining DAYS of this month-------
        adj_days_in_month(today[3])
        totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
      ----------------[2] deal with rest of this year MONTHS---------------
        adj_days_in_month(today[3])
       for x=getdec(today[2])+1 to 12 do--deal with rest of this year
          totdays=totdays+DAYS_IN_MONTH[x]
       end for
      ----------------[3] deal with the middle YEARS (if nescessary)--------
       for x = getdec(today[3])+1 to getdec(unknown[3])-1 do--deal with middle years
          a=find(sprintf("%02d",x),LEAPYEAR)
            if a then
              totdays=totdays+366
            else 
              totdays=totdays+365
            end if
       end for
      ----------------[4] deal with the last months 0f the last year---------
         adj_days_in_month(unknown[3])
       for x=1 to getdec(unknown[2]) -1 do--deal with the months of the last year
           totdays=totdays+DAYS_IN_MONTH[x]
       end for
       ---------------[5] deal with the last days of the last month----
        totdays=totdays+getdec(unknown[1])
---------------------------------------------------------------------------
   elsif getdec(today[3]) = getdec(unknown[3]) then
        if getdec(today[2]) > getdec(unknown[2]) then
              puts(1,mydate&" has passed")
              pause()
           --   abort(0)
        elsif getdec(today[2]) < getdec(unknown[2]) then
          ---------------- deal with the remaining DAYS of this month-------
            adj_days_in_month(today[3])
         totdays=totdays+DAYS_IN_MONTH[getdec(today[2])]-getdec(today[1])
          ----------------deal with the months------------
             for x=getdec(today[2])+1 to getdec(unknown[2])-1 do
                totdays=totdays+DAYS_IN_MONTH[x]
             end for
          ---------------- deal with the last days of the last month----
            totdays=totdays+getdec(unknown[1])
        elsif getdec(today[2]) = getdec(unknown[2]) then
           -------------- deal with the remaining DAYS of this month-------
        totdays=totdays+getdec(unknown[1])-getdec(today[1])
        end if
   end if
   if totdays<1 then 
          return "Date Passed"
   end if
     while totdays>700 do
       totdays=totdays-700
     end while
       while totdays>70 do
          totdays=totdays-70
       end while
          while totdays>7 do
             totdays=totdays-7
          end while
  return LONGDAY[totdays]
end function

 global function get_long_year(sequence mydate)
   integer a
   sequence ajust
    ajust={}
   a=find_last_chr("/",mydate)
    if a>0 then
         if length(mydate[a+1..length(mydate)])=2 then
              ajust= mydate[a+1..length(mydate)]
         elsif length(mydate[a+1..length(mydate)])=1 then
              ajust="0"&mydate[a+1..length(mydate)] 
         end if
           if getdec(ajust)<50 then
              return "20"&ajust
           else
              return "19"&ajust
           end if
    else
      return "no date found"
    end if
 end function

 global function getTotSecs(sequence mytime)
     integer a,b,hrs
     sequence min,secs,hour,bal
  --printf(1,"getTotSecs() entered mytime=%s",{mytime})
      a=count_chrs(":",mytime)
      if a=0 then 
         return getdec(mytime)*60 --must be mins here
      elsif a=1 then
         b=match(":",mytime)
         min=mytime[1..b-1]
         secs=mytime[b+1..length(mytime)]
         hrs=0
      elsif a=2 then
         b=match(":",mytime)
         hour=mytime[1..b-1]
         hrs=getdec(hour)
         bal=mytime[b+1..length(mytime)]
         b=match(":",bal)
         min=bal[1..b-1]
         secs=bal[b+1..length(bal)]
      end if
        return hrs*3600+getdec(min)*60+getdec(secs)
 end function

global function getSecToMin(atom secs)
 integer min min=0
  while secs>60 do
   secs=secs-60
   min=min+1
  end while
  return sprintf("%d:%0d",{min,secs})
end function

 global function getMPH(sequence dist,sequence mytime)
  atom mpg
  mpg= getdec(dist)/getTotSecs(mytime)*3600
  return sprintf("%.1f",mpg)
 end function

global function std_to_mil(sequence std)
   sequence min
  integer a,b,c,hr
   a=match("AM",std)
   b=match("PM",std)
   c=match(":",std)
    hr=getdec(std[1..c-1])
    min=std[c+1..c+2]
     if a then 
       return sprintf("%02d:%s:00",{hr,min})
     else 
       hr=hr+12
       return sprintf("%02d:%s:00",{hr,min})
     end if
end function

global function getTimePassed(sequence mydate,sequence mytime)
    sequence data
    integer nSec,oSec,secs,nMin,oMin,mins,nHr,oHr,hrs,nDay,oDay,days,oMon,nMon,oYr,nYr,
            months,yrs
      if match("M",mytime) then
      --  puts(1,"pre mytime="&mytime&"\n")
           mytime=std_to_mil(mytime)
     --   puts(1,"post MYtime="&mytime)
      end if
     data=parse_time(gettime())
         nSec=getdec(data[3])
         nMin=getdec(data[2])
         nHr= getdec(data[1])
     data=parse_date(getdate())
         nDay=getdec(data[1])
         nMon=getdec(data[2])
         nYr= getdec(data[3])
     data=parse_time(mytime)
         oSec=getdec(data[3])
         oMin=getdec(data[2])
         oHr= getdec(data[1])
     data=parse_date(mydate)
         oDay=getdec(data[1])
         oMon=getdec(data[2])
         oYr =getdec(data[3])
         if oSec > nSec then
           nSec=nSec+60 --carry an min
           nMin=nMin-1  --subtract it
         end if
       secs=nSec-oSec
             if oMin > nMin then
                nMin=nMin+60 --carry an hour
                nHr=nHr-1    --subtract it
             end if
       mins=nMin-oMin
                if oHr > nHr then
                   nHr=nHr+24  --carry an day
                   nDay=nDay-1 --subtract it
                end if
       hrs=nHr-oHr
--notelog(sprintf("in gettimepassed1 nDay=%d oDay=%d oMon=%d",{nDay,oDay,oMon}))
                 if oDay > nDay then--orig date nowdate
               days=        DAYS_IN_MONTH[oMon]-oDay+nDay  --fiGure days in lAST MONTH  and new days
                       
                     --  nDay=nDay+ DAYS_IN_MONTH[nMon]           --carry a month
                       nMon=nMon-1                                       --subtract it
                --     days =days left in last month + days in this month
                     --last momth = days oin last month - oDay\]
                  --   days=DAYS_IN_MONTH[oMon]-oDay + nDay
                 else
                  -- days=nDay=oDay
                     -- days=DAYS_IN_MONTH[oMon]-oDay+nDay
--notelog(sprintf("DAYS_IN_MONTB[oMon]=%d",DAYS_IN_MONTH[oMon]))
---notelog(sprintf("oDay=%d nDay=%d ",{oDay,nDay}))
                 --   spot=nMon+1--i fixed an error here i think was oMon
                  --    if spot=13 then 
                 --       spot=1
                --      end if
               --     nDay=nDay + DAYS_IN_MONTH[spot]
               --     nMon=nMon-1
  days=nDay-oDay
                 end if

    
--notelog(sprintf("in gettimepassed **nDay=%d oDay=%d",{nDay,oDay}))
     --  days=nDay-oDay
                 if oMon > nMon then
                    nMon=nMon+ 12
                    nYr=nYr-1
                 end if
       months=nMon-oMon
       yrs=nYr-oYr
--notelog(sprintf("in gettimepassed days=%d",days))
   return {days} & {hrs} & {mins} & {secs} & {months} & {yrs}
end function

global function all_to_secs(sequence mydate,sequence mytime)  
    sequence junk
    atom yr,tMon,tDay,tHr,tMin,tSec
     junk=getTimePassed(mydate,mytime)
       yr=junk[6]
       tMon=junk[5]+yr*12
       tDay=junk[1]+tMon*30
       tHr=junk[2]+tDay*24
       tMin=junk[3]+tHr*60
       tSec=junk[4]+tMin*60
--   printf(1,"yr=%d \n",{yr})
   -- printf(1,"tMon=%d\n",{tMon})
--  printf(1,"tDay=%d \n",{tDay})
--  printf(1,"tHr=%d \n",{tHr})
--  printf(1,"tMin=%d \n",{tMin})
--  printf(1,"tSec=%d \n",{tSec})
   return tSec
end function

global function get_days_passed(sequence mydate)
  sequence s
     s=getTimePassed(mydate,"00:00:00")
 return s[1]+s[5]*30
end function

global function get_countdown(sequence mydate,sequence mytime)
  object mons,days,hrs,mins,secs,nSec,nMin,nHr,nDay,nMon,oSec,oMin,oHr,oDay,oMon,nYr,oYr,yrs
  sequence data
     data=parse_time(gettime())
     nSec=getdec(data[3])
     nMin=getdec(data[2])
     nHr=getdec(data[1])
     data=parse_date(getdate())
     nDay=getdec(data[1])
     nMon=getdec(data[2])
     nYr=getdec(data[3])
       data=parse_time(mytime)
       oSec=getdec(data[3])
       oMin=getdec(data[2])
       oHr=getdec(data[1])
       data=parse_date(mydate)
       oDay=getdec(data[1])
       oMon=getdec(data[2])
       oYr=getdec(data[3])
         if oSec < nSec then 
            oSec=oSec+60
            oMin=oMin-1
         end if
         secs=oSec-nSec
            if oMin < nMin then
               oMin = oMin + 60
               oHr=oHr-1
            end if
        mins=oMin-nMin
              if oHr < nHr then
                 oHr=oHr+24
                 oDay=oDay-1
              end if
         hrs=oHr-nHr
                  if oDay < nDay then
                     adj_days_in_month(oYr)
                     oDay=oDay+DAYS_IN_MONTH[oMon]
                     oMon=oMon-1
                  end if
         days=oDay-nDay
                  if oMon < nMon then
                     oMon=oMon+12
                     oYr=oYr-1
                  end if
         mons=oMon-nMon
         yrs=oYr-nYr
  return {mons} & {days} & {hrs} & {mins} & {secs} & {yrs}
end function

global function get_mil_to_standard(sequence mytime)    
   integer a,hr  
   sequence hour,min,suf
     a=match(":",mytime) 
     hour=mytime[1..a-1]
      min=mytime[a+1..length(mytime)]--this is really mins And secs killed here
     hr=getdec(hour)
     if hr >= 0 and hr <12 then
         suf=" AM"
     else
         suf=" PM"
     end if
     if hr>12 then 
        hr=hr-12
     elsif hr=0 then 
        hr=hr+12
     end if
      hour=sprintf("%d",hr)
   return hour&":"&min&suf
end function

global function get_std_to_mil(sequence t)  
    integer b,hr
    sequence am_pm,hour,min,a
      b=match("M",t)
    if b=0 then
        puts(1, ">"&t   &"<<<<<<<<<<\n")
        
    end if
      am_pm=t[b-1..b]
      a=MG:match_all(":",t)

    if length(a)=1 then
        hour=t[1..a[1]-1]  
        min=MG:trim(t[a[1]+1..b-2])
          if match("PM",t) then 
            hr=getdec(hour)+12
          elsif match("AM",t) then
            hr=getdec(hour)
          end if
       --printf(1,"%d:%s\n",{hr,min})
       return sprintf("%d:%s:00",{hr,min}) 
    elsif length(a)=2 then 
       ?9/0
   end if
end function

function cut_secs(sequence mytime)  
   sequence a
   a=find_all(':',mytime)
   return mytime[1..a[$]-1]
end function

global function gettime_std()  
   sequence mytime 
     mytime=gettime()
     mytime=cut_secs(mytime)
   return get_mil_to_standard(mytime)
end function

global function est_to_pdt_with_am_pm(sequence t)     
    integer hour
    t=get_std_to_mil(t)  
    t=parse_time(t) 
    hour=getdec(t[1]) 
    hour-=3
  return get_mil_to_standard(sprintf("%d:%s",{hour,t[2]}))
end function

global function est_to_pdt(sequence mytime)
   integer a,hr
    a=match(":",mytime)
--  printf(1," %s\n",{mytime})
    hr=getdec(mytime[1..a-1])
    hr=hr-3
     if hr<1 then hr=hr+12 end if
     return sprintf("%d",hr)&mytime[a..length(mytime)]
end function

global function pdt_to_est(sequence mytime)
  integer a,hr
   a=match(":",mytime)
   hr=getdec(mytime[1..a-1])
   hr=hr+3
     if hr>12 then hr=hr-12 end if 
   return sprintf("%d",hr)&mytime[a..length(mytime)]
end function

global function pdt_to_gmt(sequence mytime)
   integer a,hr
   a=match(":",mytime)
   hr=getdec(mytime[1..a-1])
   hr=hr+7
     if hr>12 then hr=hr-12 end if
    return sprintf("%d",hr)&mytime[a..length(mytime)]
end function

global function gmt_to_pdt(sequence mytime)
   integer a,hr
   a=match(":",mytime)
   hr=getdec(mytime[1..a-1])
   hr=hr-7
     if hr<0 then hr=hr+12 end if
    return sprintf("%d",hr)&mytime[a..length(mytime)]
end function
--=with trace

global function compare_dates(sequence a,sequence b)
  sequence first,sec
-- trace(2)
    first=parse_date(a)
    sec=parse_date(b)
    if getdec(first[3]) > getdec(sec[3]) then --is year graeter
       return 1
    elsif getdec(first[3]) < getdec(sec[3]) then -- is year smaller
       return -1
    else --year the same
        if getdec(first[2]) > getdec(sec[2]) then --month 
           return 1
        elsif getdec(first[2]) < getdec(sec[2]) then --month
           return -1
        else --months the same
            if getdec(first[1]) > getdec(sec[1]) then --day
               return 1
            elsif getdec(first[1]) < getdec(sec[1]) then
               return -1
            elsif getdec(first[1]) = getdec(sec[1])  then
               return 0
            end if
        end if
    end if  
end function

---------------------------------------------------------------------
-------for more routes see date.ex in euphNFL2000
---------------------------------------------------------------------

global function get2strYear(object year)   
  sequence seq
puts(1,    "get2strYear5 enterwd\n")
  if atom(year) then
           seq=sprintf("%02d",year)
      if length(seq)=2 then
                return seq
      elsif length(seq)=4 then
              puts(1,    "from get2strYear(dec)len=4 returing " &seq[length(seq)-1..length(seq)]&"\n")
                return seq[length(seq)-1..length(seq)]
      else
        puts(1,    "this shouln't happen\n")
      end if
   elsif sequence(year) then
          
          if length(year)=4 then
        puts(1,    "from get2strYear(seq) len=4 returing " &year[length(year)-1..length(year)]&"\n")
              return year[length(year)-1..length(year)]
          elsif length(year)=2 then
                puts(1,    "from get2strYear(seq) len=2 returing " &seq &"\n")
              return year
          end if
  end if
end function

global function get4strYear(object year) 
  sequence seq  
   if atom(year) then
          seq=sprintf("%02d",year)
         if length(seq)=2 then
              return "20"&seq
         elsif length(seq)=4 then
             return seq
        --   puts(1,   "seq1 len 4 found\n")
         end if
            puts(1,    "dec found\n")
   elsif sequence(year) then
            puts(1,    "in get4strYear seq found\n")
    pause()
  end if
return 0
end function

global function get4decYear(object year)   
     if atom(year) then
    puts(1,    "in get4decYear atom found\n")
     elsif sequence(year) then
          if length(year)=4  then
             return getdec(year)
          end if
            puts(1,    "in get4decYear seq found\n")
    pause()
  end if
end function

global function getTime(atom secs)--for dos only
  integer mins
   if secs<60  then
       return sprintf("%.2f Secs\n",{secs})
   elsif secs>=60 then
      mins=secs/60
      secs=secs-mins*60
       return sprintf("%.2f Mins %.2f Secs\n",{mins,secs})
   end if
end function

global function get_day_passed(sequence mydate)
     integer a,remain,divisor
      if equal("01/03/08",mydate) then
        mydate="01/03/09"--temp for start of 2009
        end if
--  printf(1,"mydaste=%s\n",{mydate})
      a=get_days_passed(mydate)      
        divisor=floor(a/7)  
        remain=a-divisor
      --  if divisor=0 then
           --  divisor=a
     --   end if
       -- remain=7-divisor
       if remain>length(DAY) then remain = 1 end if--temp for start of 2009
--  printf(1,"remain=%d\n",{remain})
     return DAY[remain]
end function

global function get_day_anytime(sequence mydate)--get the day from any date   
   integer a 
   a=compare_dates(mydate,getdate())
--printf(1,"a=%d mydate=%s getdate()=%s\n",{a,mydate,getdate()})

--pause()
   if  a = -1 then --  passsed date
      return get_day_passed(mydate)
   elsif a =1 then -- future date
      return get_day(mydate)
   elsif a =0  then -- todays date
      return getday()
   end if
end function

global function getMinSec(atom secs)   
   integer hr,min
   atom sec
   if secs>3599 then --at lest 1 hr
           hr=floor(secs/3600)
           min=secs-hr*3600
        return sprintf("%d Hour %d Min",{hr,min})
   elsif secs>59 then --at least 1 min
           min=floor(secs/60)
           sec=secs-min*60
       return sprintf("%d Min %d Sec",{min,sec}) 
   else      
       return sprintf("%.1f Secs",{secs})
   end if
end function

global function calFracMonth(integer days) 
 integer thisMo
      thisMo=getdec(getmonth(getdate()))
--printf(1,"dim=%d days=%d fac=%f\n",{a,days,fac})
 return   days/DAYS_IN_MONTH[thisMo]
end function
------------------------------------------
--2011 2010 2009 Holiday Calendar 2009 2010 2011

--------------------------------------------------------------------------------
   


global constant holidays={"05/31/10","05/30/11","05/29/12","05/27/13",--memorial day 
                          "07/04/10","07/04/11","07/04/12","07/04/13",--Independence Day
                          "09/06/10","09/05/11","09/03/12","09/02/13",--labor day 
                          "04/02/10","04/22/11","04/06/12","03/29/13" --good friday
                           }
--------------------------------------------------------------------------------
--The tables below list the calendar days and dates of various American calendar holidays and observances. The legal status of holidays varies from state to state and the U.S. national Federal government. Some holidays are "fixed" - for example, Christmas is always December 25. Other holidays are fixed only to a particular day of the week in relation to a particular week of a fixed month - for example, Mothers Day is always the second Sunday in May. The most complicated of calendar holidays is Easter Sunday - a "movable feast" that can occur in March or April and is determined by a complex mathematical procedure. The calendars below have a total of 13 fixed calendar date holidays + 8 holidays that are fixed to a certain day of the week - Sunday (2), Monday (5), and Thursday (1) - and the complex Easter Sunday holiday along with Good Friday. Holidays are listed for calendar years 2009, 2010, 2011, 2012, 2013, 2014, 2015, and 2016. Also, a Holiday Calendar near the bottom of the page can be used to find the dates of these holiday observances for any year. This information is useful for business travel and vacation planning, and rentals and reservations for hotels / motels, autos, airlines, and cruises. A US holiday list calendar follows. 
--Calendar Holidays and Observances
--Holiday 2009 2010 2011 2012 2013 2014 2015 2016 
--MLK Jr Day -- 3rd Monday in January Jan 19 Jan 18 Jan 17 Jan 16 Jan 21 Jan 20 Jan 19 Jan 18 
--Presidents Day* -- 3rd Monday in February Feb 16 Feb 15 Feb 21 Feb 20 Feb 18 Feb 17 Feb 16 Feb 15 
--Mothers Day -- 2nd Sunday in May May 10 May 9 May 8 May 13 May 12 May 11 May 10 May 8 
--Memorial Day -- Last Monday in May May 25 May 31 May 30 May 28 May 27 May 26 May 25 May 30 
--Fathers Day -- 3rd Sunday in June Jun 21 Jun 20 Jun 19 Jun 17 Jun 16 Jun 15 Jun 21 Jun 19 
--Labor Day -- 1st Monday in September Sep 7 Sep 6 Sep 5 Sep 3 Sep 2 Sep 1 Sep 7 Sep 5 
--Columbus Day -- 2nd Monday in October Oct 12 Oct 11 Oct 10 Oct 8 Oct 14 Oct 13 Oct 12 Oct 10 
--Thanksgiving -- 4th Thursday in November Nov 26 Nov 25 Nov 24 Nov 22 Nov 28 Nov 27 Nov 26 Nov 24 
--Good Friday -- 2 days before Easter Apr 10 Apr 2 Apr 22 Apr 6 Mar 29 Apr 18 Apr 3 Mar 25 
--Easter Sunday -- March or April Apr 12 Apr 4 Apr 24 Apr 8 Mar 31 Apr 20 Apr 5 Mar 27 
------------------------
  --New Years Day -- January 1 
 -- MLK Jr Day -- 3rd Monday in January 
 -- Groundhog Day -- February 2 
 -- Valentines Day -- February 14 
 -- Presidents Day* -- 3rd Monday in February   
  --St. Patricks Day -- March 17 
 -- April Fools Day -- April 1 
 -- Earth Day -- April 22 
 -- Cinco de Mayo -- May 5 
  --Mothers Day -- 2nd Sunday in May 
  --Memorial Day -- Last Monday in May 
 -- Flag Day -- June 14 
  --Fathers Day -- 3rd Sunday in June 
 -- Independence Day -- July 4 
 -- Labor Day -- 1st Monday in September 
 -- Columbus Day -- 2nd Monday in October 
  --Halloween -- October 31 
-- Veterans Day -- November 11 
--  Thanksgiving -- 4th Thursday in November     
 -- Christmas -- December 25 
 -- New Years Eve -- December 31 
 -- Good Friday -- 2 days before Easter 
 -- Easter Sunday -- March or April  

global function sortDates(sequence dates)
   sequence times
      times=repeat({},length(dates))
        for x=1 to length(dates) do
            ? getTimePassed(dates[x],"00:00:00")  
            times[x]=getTimePassed(dates[x],"00:00:00")
        end for
  return times
end function

global function getYearOnly(sequence mydate)
   sequence yr
       yr=parse_date(mydate)
   return yr[3]
end function

global function getDayOnly(sequence mydate)  
   sequence day
     day=parse_date(mydate)
   return day[1]
end function

global function  getDayOfYear(sequence mydate) 
   sequence s,todays_date,junk
   integer todays_day_of_year,daysPassed

     s=date()
                    --s[1]=      { year,    -- since 1900
                    --s[2]=           month,    -- January = 1
                    --s[3]=        day,      -- day of month, starting at 1
                    --s[4]=        hour,    -- 0 to 23
                    --s[5]=        minute,  -- 0 to 59
                    --s[6]=        second,  -- 0 to 59
                    --s[7]=day of the week, -- Sunday = 1
                    --s[8]=day of the year} -- January 1st = 1
                todays_day_of_year=s[8]
                todays_date=getdate()
                junk=getTimePassed(mydate,"00:00:00")
                daysPassed=junk[1]
            --  ?junk[1]
    return todays_day_of_year-daysPassed
end function

global function getDiyToday()--day in year today
    sequence s
      s=date()
        return s[8]
end function

global function convertDate(sequence mydate)
     sequence yr,year,bal,day,mo           
     atom a
         a=match("/",mydate)
        mo=sprintf("%02.1s",mydate[1..a-1])
        bal=mydate[a+1..$]
         a=match("/",bal)
                            day="0"&bal[1..a-1]
                            day=day[$-1..$]
         year=bal[a+1..$]--4 dig year
       yr=year[3..4]
  return mo&"/"&day&"/"&yr
end function
