include mylog.e

global function wCheckFile(sequence file_path)
   integer fn  
   object junk
      junk = setSearchPaths(file_path)
      fn = w32FileOpen(file_path, "r") -- looks in the search paths   
          if fn=-1 then
                      junk = message_box(   file_path, 
                     "Can't Find File",
              MB_ICONHAND+ MB_TASKMODAL )
           return 0
          end if
          close(fn)
       return 1
end function
  
global function select_file(integer win)  
              sequence filename
                      filename = getOpenFileName(
                          win,                  -- parent window
                          "",                         -- no default name
                          {"Euphoria Program", "*.EX;*.EXW;*.E;*.EW",    -- euphoria files
                            "All Files", "*.*" } )    -- everything else
  return filename
end function    

------------------------------------
--include dll.e
--include file.e
--include machine.e
--object void
 constant 
 k32 = open_dll("kernel32.dll"),
GetCurrentDirectoryA = define_c_func( k32, "GetCurrentDirectoryA", {C_INT, C_POINTER}, C_INT ),
SetCurrentDirectoryA = define_c_func( k32, "SetCurrentDirectoryA", {C_POINTER}, C_INT )

function pwd()
      atom buf, chars
      sequence d
      buf = allocate( 1025 )
        chars = c_func( GetCurrentDirectoryA, {1024, buf})--
       d = peek( buf & chars )
        free( buf )
        return d
end function

global procedure changeDir( sequence d )
      atom buf, ok
       buf = allocate_string( d )
      ok = c_func( SetCurrentDirectoryA, {buf})
     free(buf)
end procedure

global procedure checkdir()
      printf(1, "current_dir: '%s'\n", {current_dir()})
      printf(1, "Win32:       '%s'\n\n", {pwd()})
end procedure

--puts(1, "The starting current_dir():\n")
--checkdir()

--puts(1, "Calling chdir(\"..\")\n")
--void = chdir("..")

--checkdir()

--puts(1, "Calling cd(\"..\")\n")
--cd( ".." )

--checkdir()

global procedure browse(integer TheWindow,integer outId,sequence browseDir)
          sequence filename

          filename = getOpenFileName(
                          TheWindow,                  -- parent window
                          browseDir,                          -- no default name
                          {-- "Text File", "*.TXT",   -- text files
                            "All Files", "*.*" } )    -- everything else
         setText(outId,filename)
end procedure
