include get.e as GE
include font.e
include type.e
include msgbox.e

--include win32lib.ew

global function remove_commas(sequence s) --remove all commas
  integer x,a
     x=0
--printf(1," in remove_commas in  s=%s\n",{s})
    while x < length(s)+1 do
        x+=1
         a=find(',',s)
          if a then
             s=s[1..a-1]&s[a+1..$]   
          end if
    end while
--printf(1," in remove_commas out s=%s\n",{s})
    return s
end function

global function remove_xtra_zeros(object price)    
   sequence p
   integer x
     --  if sequence(price) then
    --       price=sprintf("%f",price)
      -- end if
       if atom(price) then
            p=sprintf("%f",price)
       elsif sequence(price) then
            p=price 
       end if
            x=length(p)
               if x=0 then
                  return ".00"
               end if
               while equal('0',p[x]) do
                    x-=1
                    p=p[1..x]
               end while
            return p
end function

global  function add_zeros(sequence price)
  integer a  
  sequence tail
         a=match(".",price)
           tail=price[a+1..$]
      if length(tail)>1 then
          return price
      elsif length(tail)=1 then
          return price&"0"   
      elsif length(tail)=0 then
          return price&"00" 
      end if
end function 

global function getdec(sequence seq) --returns a decimal given a sequence
--atom de
sequence value_seq
integer a 
     a=match(",",seq)
       if a then
          seq=remove_commas(seq)
       end if
--printf(1,"in getdec seq=%s \n",{seq})
  value_seq=GE:value(seq[1..length(seq)])
--printf(1,"value_seq[2]=%d \n",{value_seq[2]})
--printf(1,"value_seq[1]=%d value_string[2]=%f\n\n",{value_seq[1],value_seq[2]})
-- de = value_string[2]
return value_seq[2]
end function

global function get_seq(atom dec)--returns a sequence given a decimal
 sequence string
   string=sprintf("%7.2f",dec)
 return string
end function

global function get_seq2(integer dec,sequence chr)--returns a sequence given a decimal
 sequence string                                  --and add a pre letter     
   string=sprintf("%s%d",{chr,dec})
 return string
end function

global function getdec2(sequence seq)--returns a decimal formatted in dollars & cents given a seq
  atom dec
        dec=getdec(seq)
   return dec
end function

global function input(sequence prompt)
   sequence answer
    puts(1,prompt)
    answer=gets(0)
    answer=answer[1..length(answer)-1]
    puts(1,"\n")
  return answer
end function

global procedure stall(integer len)
      for x=1 to len*10000 do
         for y=1 to 10000 do
         end for
      end for
end procedure

global procedure pause()
  object ii
       puts(1,"\n\t[ANY KEY] = Continue     [F1] = Force Error          [Esc] = Exit     \n")
 ii=wait_key()
   if ii=27 then
    abort(0)
   elsif ii=315 then
     ?9/0 
   end if
end procedure

global function question_pause(sequence item)
  integer i
  text_color(YELLOW)
    if length(item)>6 then
        item=item&"\n"
    end if
   while 1=1 do
    puts(1,"\n    [Return] = "&item&"     [Esc] = Do Nothing      [F1] = Force err\n")
      if platform()=WIN32 then
      --    clickPointerLeft()  
      end if
    i=wait_key()
      if i=13 then
        return 1
      elsif i=27 then
        return 0
      elsif i=315 then
       ?9/0
      end if
   end while
end function


global function save_as(sequence item)
   integer a
   a=question_pause("Save as: "&item)
   return a
end function

global procedure save_pause()
   integer a
   a=question_pause("Save")
    if a !=1 then
      abort(0)
    end if
end procedure

global function yes_no(sequence item)  
   integer i i=0
     puts(1,item&" (y-n)")  
       while i !=110 and i !=121    do
         i=wait_key()
          printf(1,"%s\n",{i})
           if i !=121 and i !=110 then
              i=yes_no(item)
           end if
        end while  
       return i
end function

global function del_lead(object line)       -- delete any leading whitespace
  --  while 1 do
    --line = gets(KEYBOARD)
--  ?length(line)
    if sequence(line)  and length(line)>0 then
        -- delete any leading whitespace
      --  for x=length(line) to 1 by -1 do
    --    printf(1,"%d %s\n",{x,line[x]})
--  end for
    
--  pause()
        while find(line[1], " \t\n") do
        line = line[2..length(line)]
        if length(line) = 0 then
            exit
        end if
        end while
     --   if length(line) > 0 then
        --exit
      --  end if
    end if
    --puts(SCREEN, "\n? ")
 --  end while
   return line
end function

global function del_trail(object line)    -- delete trailing whitespace
 --  printf(1,"line=>%s<\n",{line})
 --  pause()
if length(line)<2 then
  return " "
 end if
--notelog(sprintf("line=>%d< len=%d",{line,length(line)}))
    while find(line[length(line)],  " \t\n" ) do--WHITE_SPACE
       line = line[1..length(line)-1] 
    end while
  return line
end function

global function trim(object line)
    if sequence(line) and length(line)>0 then
        -- delete any leading whitespace
        while find(line[1], " \t\n") do
        line = line[2..length(line)]
        if length(line) = 0 then
            exit
        end if
        end while
    end if
     if sequence(line) and length(line)>0 then
       -- delete trailing whitespace
       while find(line[length(line)], " \t\n") do
         line = line[1..length(line)-1] 
       end while
     end if
    return line
end function 

global function myfgets(sequence prompt)
 sequence item
  item=fgets(prompt)
  item=item[length(prompt)+1..length(item)]
return item
end function


global function wait_key_dec()--conerts a keystroke to a decimal
  integer decimal,euph
  sequence seq
  euph=wait_key()
  seq=sprintf("%s",{euph})
  decimal=getdec(seq)
  return decimal  
end function

global function input_dec(sequence prompt)
 atom dec
 sequence euph,seq
  euph=input(prompt)
  seq=sprintf("%s",{euph})
  dec=getdec(seq)
return dec
end function

global function asc(object letter)--returns asc code as a sequece
  sequence dec
    if sequence(letter) then
       dec=sprintf("%d",letter)
       return dec 
    elsif atom(letter) then
       return letter
    end if
end function

global function find_last_chr(sequence chr,sequence string)
 integer a,b
  b=0
  a=match(chr,string)
   if a = 0 then
     b=a
   elsif a > 0 then
      while 1=1 do
       b=b+a
        a=match(chr,string[b+1..length(string)])
          if a = 0 then
            exit
          end if
      end while
   end if
 return b
end function

--global function count_chrs(sequence chr,sequence string)
-- integer a,b,amount
  --b=0
  --amount=
--  a=match(chr,string)
 --  if a = 0 then
  --   b=a
  -- elsif a > 0 then
     -- while 1=1 do
     --  b=b+a
     --   a=match(chr,string[b+1..length(string)])
        --  if a = 0 then
        --    exit
       --   end if
     --   amount=amount+1
     -- end while
  -- end if
-- return amount
--end function

global function count_chrs(sequence chr,sequence string)
   integer a,count
   a=match(chr,string)
    if a=0 then
      return 0
    else
      count=0
      for x=1 to length(string) do
         if match(chr,string[x..x]) then
            count=count+1
         end if
      end for
       return count
    end if  
end function

 global function get_index(sequence choice)
   integer idx,i
   puts(1,"\n\n")
    for x= 1 to length(choice) do
      printf(1,"[ %d ] %s\n",{x,choice[x]})
    end for
     i=wait_key()
     idx=i-48
   return idx
 end function

 global function get_index_across(sequence choice)
   integer i
   puts(1,"\n\n")
    for x= 1 to length(choice) do
      printf(1,"[%d]%s ",{x,choice[x]})
    end for
     i=wait_key() 
--puts(1,"\n")
      for x=1 to length(choice) do
          if equal(x,i-48) then
             return i-48
          end if
      --   printf(1,"%d %d\n",{x,i-48})
      end for
-- pause()
   --  idx=i-48
   return 1--always return some thing good if none found
 end function

 global function get_seq_abs(sequence num)
    if match("-",num) then
      return num[2..length(num)]
    else
      return num
    end if
 end function

 global function remove_minus(atom digit)--retens a dec without minus sign  
     sequence junk
     junk=sprintf("%f",digit)
     return getdec(junk[2..$])
 end function

global function int(atom num)
  integer dec
  sequence seq
    seq=sprintf("%d",num)
        while equal("-",seq[1..1]) do
            seq=seq[2..$]
        end while
    dec=getdec(seq)
  return dec
end function

global function my_int(object in)
   sequence seq  ,value_string
   integer de

   if atom(in) then
     seq=sprintf("%d",in)
  value_string=value(seq)
 de = value_string[2]
--puts(1, get_type(de)   &"<oo<<<<<<<<<<<<<<<<<<<<<\n")
return de
       

   elsif sequence(in) then
         ?9/0
   end if
end function

global function my_find(object a,sequence b)
    a=trim(lower(a))
    b=trim(lower(b))
   return find(a,b)
end function

global function my_match(sequence a,sequence b)
   --maches 2 squences of anny length
    a=trim(lower(a))
    b=trim(lower(b))
   return match(a,b)  
end function

global function my_match2(sequence a,sequence b,integer len)
   integer an    --maches 2 squences of a specified length
    a=trim(lower(a))
    a=a[1..len]
    b=trim(lower(b))
    b=b[1..len]
    an=match(a,b)  
   return an
end function

global function my_compare(sequence a,sequence b)
  a=trim(lower(a))
  b=trim(lower(b))
  return compare(a,b)
end function

global function get_percent(atom d1,atom d2)  --returns dec
puts(1,"here")
   if d2 =0 then
--puts(1,"zero here")
--pause()
       return 0
   else
       return int((d1/d2)*100)
    end if
end function

global function percent(atom amt, atom tot)  --returns string
   if tot=0 then  
      return "0%"
   else
      return sprintf("%3.f%%",{amt/tot*100})   
   end if
end function

global function isWholeNum(atom num)
  sequence text 
  integer a
   text=sprintf("%f",num)
   a=find('.',text)
   text=text[a+1..$]
   if getdec(text)=0 then
     return 1
   else
     return 0
   end if
end function

global function get_oddeven(integer num)
    if and_bits(num, 1) then 
       return 1--odd
    else
        return 2--even
    end if
  -- atom half
    --half=num/2
----    if half = int(half) then
--    return 2
--  end if
--  return 1
end function

  global function clean_half(object line)
   sequence test
    if length(line)=0 then
       return line
    end if
   test=asc(line[length(line)..length(line)])
   if match("189",test) then 
      line=line[1..length(line)-1]&".5"
   end if
  return line
  end function

 global function get_text_dec(integer num)
   sequence text,dec
   integer a
   text={"zero","one","two","three","four","five","six","seven","eight","nine","ten"}
   dec={0,1,2,3,4,5,6,7,8,9,10}
    a=find(num,dec)
    return text[a]
 end function
----------------------------------------------------
-- Locates the all the occurances of the specified element in a sequence
-- Returns a sequence listing each occurance. If none found an empty sequence is returned.
global function find_all(object pElement, sequence pSource)
    sequence lFound
    lFound = {}
    for i = 1 to length(pSource) do
        if equal(pElement, pSource[i]) then
            lFound &= i
        end if
    end for   
    return lFound
end function

 global function match_all(sequence  element,sequence source)  
   sequence a a={}
   for x=1 to length(source)  do
--  printf(1,"%d >%s< >%s<\n",{x,element,source[x..x]})
        if match(element,source[x..x]) then
           a= append(a,x)
        end if
   end for
  return a
 end function

global function match_all2( sequence s1, sequence s2 )
-- returns: sequence containing indices of all matches
--   if unsuccessful return empty sequence {}
  object found

  found = match( s1, s2 )
  if found then
    found &= found + match_all2( s1, s2[found+1..length(s2)] )
  else
    return {}
  end if

  return found

end function


global function lower_word(sequence word)
    sequence pre,post
     if length(word)=0 then
        return{}
    end if
     pre=upper(word[1..1])
     post=lower(word[2..length(word)])
   return pre & post
 end function

global function cap_firsts(sequence s)  
   s[1]=upper(s[1])
    for x=2 to length(s)  do
        if equal(' ',s[x]) then
            s[x+1]=upper(s[x+1])
        end if
    end for
  return s
end function

global function cap_firsts86(sequence s)
  sequence b,word1,word2,word3
   s=lower(s)
   b=find_all(' ',s)
    if length(b)=0 then
       return lower_word(s)
    elsif length(b)=1 then
        word1=lower_word(s[1..b[1]])
        word2=lower_word(s[b[1]+1..length(s)])
           return word1 & word2
    elsif length(b)=2 then
        word1=lower_word(s[1..b[1]])
        word2=lower_word(s[b[1]+1..b[2]])
        word3=lower_word(s[b[2]+1..$])  
    else
        ?length(b)
        puts(1,s    &"\n")
        ?9/0
         return {}&{}&{}
    end if
   return word1 & word2 & word3
end function

global function cap_firsts_line(sequence s)--whole line must be all caps for this to work
integer sw
 sw=0
   for x=1 to length(s) do
   --    n[x]=s[x]
     if Uppers(s[x]) and sw=1 then
        s[x]=lower(s[x])
     end if  
     if Uppers(s[x]) or Lowers(s[x]) then
       sw=1
     else 
       sw=0
     end if 
   end for
  return s
end function
------------------------------basic names---------------
--global function INT(atom num)
   -- integer a   
   -- sequence num2

 -- num2=sprintf("%f",num)

  --a=match(".",num2)
--?getdec(num2[1..a-1])
 -- return getdec(num2[1..a-1])
--end function


---------------------------------------------------------------------
-------for more routes see date.ex in euphNFL2000
---------------------------------------------------------------------
  global type isNum(integer ch)--input dec,output dec
    return ch >= '0' and ch <= '9'  
  end type
    
global function  getNumOnly(sequence s)--for like taking 20 ot of 20th
   sequence num  num={}--input is seq ,output dec
    for x=1 to length(s) do
       if isNum(s[x]) then
        num&=s[x]
       end if
    end for
    return getdec(num)
end function

 global function my_get_bytes(atom amt)   
     if amt/1024/1024/1024 >= 1 then 
         return({sprintf("%.1f",amt/1024/1024/1024)}&{"Gig"})
     elsif amt/1024/1024 >=1 then
         return({sprintf("%.1f",amt/1024/1024)}&{"Meg"})
     elsif amt/1024 >= 1 then 
         return({sprintf("%.1f",amt/1024)}&{"K"})
     else
         return({sprintf("%d",amt)}&{""})
     end if
  end function
  
 global procedure len(sequence seq)
    printf(1,"len=%d\n",{length(seq)})
 end procedure

global function my_message(sequence app,sequence message,integer tab)
        integer response
              response = message_box(message,
                                     app,
                                    tab)
        return response
end function

  global function getAmt(atom amt)   
     if amt/1024/1024/1024 >= 1 then 
     return({sprintf("%.1f",amt/1024/1024/1024)}&{"Gig"}&{"Gig"})
     elsif amt/1024/1024 >=1 then
         return({sprintf("%.1f",amt/1024/1024)}&{"Meg"}&{"Meg"})
     elsif amt/1024 >= 1 then 
         return({sprintf("%.1f",amt/1024)}&{"K"}&{"K"})
     else
         return({sprintf("%d",amt)}&{"Bytes"}&{""})
     end if
  end function 

global function getAmtFixed(atom amt)
    sequence junk
      junk=getAmt(amt)
      return junk[1]&" "&junk[2]
end function

global procedure prtSeq1(sequence s)--print to screen a 1 element sequence
   for x=1 to length(s)  do
    printf(1,"%d %s\n",{x,s[x]})
   end for
end procedure

global function makeMinus(atom amt)  
    sequence s,change
      s=sprintf("%f",amt)
      change="-"&s
   return getdec(change)
end function

with trace
global function getProperPriceSeq(object sPrice)     
     integer a,len    
     atom price
     sequence seq,test
      if atom(sPrice) then
          price=sPrice
          sPrice=sprintf("%f",sPrice)
          sPrice=remove_xtra_zeros(sPrice)
      else 
          price=getdec(sPrice)  
      end if
            a=match(".",sPrice)
            len=length(sPrice[a+1..$])--get the  length after the decimal point
            if len<3 then
            --  printf(1,"%%.%.df",2)
                -- return sprintf("%%.%.df",2)
                seq=sprintf("%%.%.df",2)
            else
                seq=sprintf("%%.%df",len)
                -- return sprintf("%%.%df",len)
            end if
            test=sprintf(seq,price)
               if equal(test[1],'0') then       
                   test=test[2..$]
               end if
            return  test    --sprintf(seq,price)
end function

global function getProperPrice(object p)
 sequence seq,sPrice
 atom price
  if sequence(p) then
      price=getdec(p)
      sPrice=p
      sPrice=remove_xtra_zeros(sPrice)
      seq=getProperPriceSeq(sPrice)
    return sprintf(seq,price)
  elsif atom(p) then
         printf(1,"price ia an atom=%f\n",{p})         
         pause()
         --  return getProperPriceSeq(get_seq(price))   
  end if
  --return {}
end function





