--all.e  function that go with ALL stats files

--include week.e
--include view.e
--include wildcard.e
--include myfile.e


  global function get_amain_week()--and year
    sequence weekg,yearg,last
    integer decyearg,week
 --  trace(1)
    last=load(AMAIN_WEEK_PATH)
    weekg=last[2]
    week=weekg[2]
    weekg=sprintf("%d",weekg[2])
    yearg=last[1]
    decyearg=yearg[2]+1996
     if decyearg > 1999 then
       decyearg=decyearg-2000
       yearg=sprintf("%02d",decyearg)
     else
       decyearg=decyearg-1900
       yearg=sprintf("%d",decyearg)
     end if
     --  puts(1,"amain.dat = week ")
--?week
    --   pause()
    --  if decyearg < 1 then 
--   puts(1,"in all.e (25) year incorrect readsing from amain.dat")
    -- ?decyearg
    -- pause()
    --  decyearg=2005
     -- end if
    return {weekg} & {yearg} & week----yearg="03" form  --weekg="1" form form
  end function                      --week a decimal   
  
  global function get_amain_yr()  
   sequence year
    year=getText(YEAR)
    return year[3..4]
  end function
  
global function get_amain_year_dec_long()
    sequence yr
    yr=getText(YEAR)  
    return getdec(yr)
end function

  global function get_amain_year_dec() 
     return getdec(get_amain_yr())
  end function

  global function get_amain_yr2222()--may not use
     sequence week_data
     week_data=get_amain_week()
      -- week_data[2]="2005"
     return week_data[2]--returns string
  end function
  
  global function get_amain_week_only()--returns str
    integer a
    sequence week
      week=getText(WEEK) 
      a=match(" ",week)
      return week[a+1..$]
  end function  

  global function get_amain_week_dec()
    return getdec(get_amain_week_only())
  end function  

  global function open_stats(sequence file,sequence purpose)
    sequence week_data2,fileName,yr5,myweek
    integer week--key to problem
    object fn5
     week_data2=get_amain_week()--the last week selected really alldata(week,year.
     week=get_amain_week_dec()
     yr5=week_data2[2]
     myweek=week_data2[1]
    -- week=week_data2[3]
     fileName=STATS_PATH & yr5 & COL_OR_NOT3 & "\\" & file & myweek & ".dat"
--  puts(1,fileName)
 --  pause()
     fn5=my_open(fileName,purpose)
     return fn5 & {fileName} & week
  end function

global function read_out(sequence pageline,integer mostcommas,integer highest,sequence widest)
  ---------------------FOURTH PASS (pad and RETURN all print out data)---------------
   --this is a subroute of read_all
   integer commas,amount_to_pad
   sequence usage,data,padded,database,temp_rec
       database={}
      for x= 1 to length(pageline) do 
           commas=count_chrs(",",pageline[x])
          if commas=mostcommas then--make sure it is a regular line
              usage=line_use(pageline[x])
              data=usage[2]
             temp_rec={}
              for y=1 to highest do
                amount_to_pad=widest[y]-length(data[y])
                  padded=repeat(' ',amount_to_pad)
                    if widest[y]=0 then
                       padded="---"
                    end if
             --    puts(1,padded)
               --  puts(1,data[y])
              --   puts(1," ")
                 temp_rec=temp_rec & padded & data[y] & ","
              end for
            database=append(database, temp_rec)
         --  puts(1,"\n")
         end if
      end for
   return database
end function
--with trace
global function read_all(sequence file)
   --this reads all data of any sheet
   object line,fn,my_dl_file
   integer mostcommas,highest,week
   sequence page1line,widest,both,pageline,database,fileinfo,fileName,first_line
--trace(2)
--printf(1,"file=%s\n",{file})
--pause()
    database={}
    first_line={}
    fileinfo=open_stats(file,"r")
    fileName=fileinfo[2]
    fn=fileinfo[1]
--  ?fn
    week=fileinfo[3]
   -- db=read_all(fileinfo[1],fileinfo[2])
   my_dl_file={}
  if fn=-1 then 
     puts(1," In read_all() Can't open " & fileName )
    -- abort(0)
  else   -----------------------read first lines----------
          line=gets(fn)
            if atom(line) then 
               puts(1,"in read_all() NO DATA in >" & fileName)
              -- abort(0)
            end if
        if match("spread",fileName) then
             first_line=line
             my_dl_file=gets(fn)
        elsif match("pred",fileName) then
             first_line=gets(fn)
             my_dl_file=gets(fn)
           if atom(my_dl_file) then 
               puts(1,"in read_all() Insificent DATA in >" & fileName)
           end if
        elsif match("score",fileName) then
              first_line=line
               my_dl_file={}
        elsif match("result",fileName) then
              first_line=line
        elsif match("consen",fileName) then
              first_line=line
        elsif match("sumup",fileName) then
              first_line=line
              my_dl_file=gets(fn)--kill some lines
              my_dl_file=gets(fn)--kill some lines
        else --reopen to keep first line
           --  first_line=gets(fn)
           --  my_dl_file=gets(fn)  
             close(fn)
             fileinfo=open_stats(file,"r")
        end if
        ---------------------------------------------------------------
         if atom(line) then 
            puts(1,"in read_all() NO DATA in:" &fileName)
         --   abort(0)
         end if
          -------------------read the page 1 file----------------
         page1line={}
          while 1=1 do
             line=gets(fn)
               if sequence(line) then
                 page1line=append(page1line,line)
               else 
                  exit
               end if
          end while
          close(fn)
          pageline=page1line
     ------------------SECOND PASS ( analize data get the most commas)--
      mostcommas=get_mostcommas(pageline)
         --------- THIRD PASS (get highest number of colums used and colum widths)------------
       both=get_widest(pageline,mostcommas)
       highest=both[1]
       widest=both[2]
     --------------------------FOURTH PASS (pad and read out data)---------------
      database=read_out(pageline,mostcommas,highest,widest)---a sub route of this function
  end if
  return {database} & {my_dl_file} & week & {first_line} 
end function

global function overwrite_warning(sequence fileName)
  integer i
  object fn
   text_color(BRIGHT_WHITE)
    fn=open(fileName,"r")
       if fn>0 then 
           close(fn)
           puts(1,"\n\n Replace existing file> "&fileName&" ?\n\n")
          text_color(YELLOW)
           while 1=1 do
                  puts(1,"      [RETURN]=Yes        [ESC]=No      [u]=Update")
                   i=wait_key()
                   puts(1,"\n")
                    if i=13 then --y
                      return 1
                    elsif i =27 then --n
                      return 2
                    elsif i=117 then --u
                      return 3
                    end if
           end while
        else
          puts(1,"\n\n Save file> "&fileName&" ?\n\n")
            text_color(YELLOW)
             while 1=1 do
                puts(1,"      [RETURN]=Yes        [ESC]=No")
                i=wait_key()
                if i=13 then
                  return 1
                elsif i=27 then 
                  return 2
                end if
             end while
        end if
end function

global function reconstruct_line(sequence line)
   sequence con_line
    con_line={}
       for x= 1 to length(line) do
        con_line=con_line&line[x]&","
    end for
 return con_line
end function

     global procedure save_win_data(sequence win_data)
        object fn
        fn=my_open("win_data.dat","w")
        print(fn,win_data)
        close(fn)
     end procedure

global procedure update_win(integer x)
        sequence win_data,week
         week=get_amain_week_only()
               win_data=load("win_data.dat")
         win_data[x][1]=sprintf("Week %2s",{week})
         win_data[x][2]=getdate()
         win_data[x][3]=gettime()
         save_win_data(win_data)
end procedure
