--feist read asp
--global constant WEEK_PATH="c:\\euph_nfl03\\alldata.dat"
  include wildcard.e
  include mygets.e
  include mydate.e
  --include teamcodes.e
  include week.e
  include mylog.e
   without warning

  function clean_asp_date(sequence mydate)
   integer a
   a=match("<",mydate)
     if length(mydate[1..a-1]) > 2 then
       return clean_date(mydate[1..a-1])
     else
      return mydate      
     end if
  end function
 
  function clean_asp_time(sequence mytime)
      integer a
       a=match("<",mytime)
       if a=0 then
          puts(1,mytime)
          pause()
       end if
       mytime=mytime[1..a-2]
       return mytime
  end function

  function clean_spread(sequence spread)
   sequence feist,nasa
   integer a,b
      feist=spread
     a=match("-",spread)
     b=match("+",spread)
       if a >0 then 
        spread=trim(spread[1..a-1])
       elsif b>0 then
        spread=trim(spread[1..b-1])
       end if
      a=match(" ",spread)
     if a >0 then
        feist=spread[1..a-1]
        nasa=trim(spread[a..length(spread)])
        feist=clean_half(feist)
     else
        if length(feist) > 0 then
           feist=clean_half(spread)
        end if
    end if
   return feist
  end function


 function get_line_type(sequence line)
        integer a
        sequence testline
        atom first_val
        line=trim(line)
                a= match(" ",line)   
    if a>0 then--a space was found
                testline=line[1..a-1]
                first_val=getdec(testline)
            if length(testline)=2 then
                 testline=testline&' '--in case team code only has 2 letters
            end if
                 if not compare("NY",line[1..2]) then
                     return "team"
                 elsif  find(testline,FEIST_CODE) then
                     return "team"
                 elsif first_val >0 or first_val<0 then
                     if length(line)>5 then
                        return "longspread"
                     else
                        return "shortspread"
                     end if
                 elsif match("PK",line) then
                     if length(line)>5 then
                        return "longspread"
                     elsif getdec(line)>0 then
                        return "longspread"--don't work don't need
                     end if 
                 end if
    elsif match(".",line) then
        return "rotation"
    elsif getdec(line)>0 then
       return "shortspread"
    end if
   return "unkown"
 end function

 function clean_team(sequence line)
           integer a
           sequence testline
           a= match(" ",line) 
              testline=line[1..a-1]
              if length(testline)=2 then
                   testline=testline&' '
              end if
                if not compare("NY",line[1..2]) then
                        testline=line[1..2]&line[4..4]
                end if
               a= find(testline,FEIST_CODE)
              if a>0 then
                      return MYTEAMS2[a]
                   else
                 puts(1,testline)
                 abort(0)
               end if
 end function

 function clean_generated(sequence line)
  integer a,b
  a=match("generated",line)
  b=match("<",line[a..length(line)])+a-2
 -- printf(1,"line=>%s<  a=%d b=%d",{line,a,b})
  return line[a..b]
 end function

 global procedure print_feist(integer fn3)
----------------------------start of program---------------------
  object fn,line,fn1
  integer a,b,d,c,e,f,g,h,i,j,game,sw,x,z
  sequence last_generated,aline,mytype,mydate,mytime,gamedate,testline,vis,home
  sequence homespread,visspread,fav,dog,sprd,ou,line_type,week,myday ,gameday,year  
   atom v,hm
  clearlog()
 last_generated="Generated ?"
  fn=my_open("dload.asp","r")
   week=getweek()
  --fn1=open("c:\\windows\\feist"&week&".txt","w")
  puts(1,"c:\\windows\\feist"&week&".txt")
  aline={}
  while 1=1 do
    line=trim(gets(fn))
    if atom(line) then
        exit
    else
     a= match("<pre>",line) 
     b=match("</td>",line)
     c=match("HTML",line)
     d=match("HREF",line)
     e=match("Badlands",line)
     f=match("http",line)
     g=match("table",line)
     h=match("peru",line)
     i=match("Openers",line)
     j=match("generated",line)
       if j>0 then 
         last_generated=clean_generated((trim(line)))--store generated date
       -- puts(fn1,last_generated)
        puts(1,last_generated)
   --  abort(0)
         line=""
       
       elsif  d>0 or c>0 or e>0 or f>0 or g>0 or h>0 or i>0 then
         --do nothing
         line=""
       elsif a>0 then
         line=trim(line[a+5..length(line)])--cut off pre
       elsif b>0 then
         line=trim(line[1..b-1])--cut off /td

       end if 
         if length(line)>0 then
               aline=append(aline,line)
         end if
    end if
  end while 
 --------------------------second pass-------------------------
     game=0
     sw=0
     mytype=repeat({},length(aline))
     mytime=mytype
     mydate=mytype
     myday=mytype
     vis=repeat({},18)
     home=repeat({},18)
     homespread=vis
     visspread=vis
       for y=1 to length(aline) do
        ---------------time------------------
        if match(":",aline[y]) then --and not match("{",aline[y]) and not match("tp://",aline[y]) then--
        --  puts(1,aline[y])
--pause()
           mytype[y]="time"
        -----------------date--------------------
        elsif match("/",aline[y]) and match("0",aline[y]) then
            mytype[y]="date"
        else
            mytype[y]=get_line_type(aline[y])    
        end if
       end for
------------------------next pass--------------------------
    x=0
    while x<length(aline) do 
       x=x+1
    --    printf(1,"%d %s *>%s<*\n",{x,mytype[x],aline[x]})
   notelog(sprintf("%d %s *>%s<*\n",{x,mytype[x],aline[x]}))
         if match("date",mytype[x]) then
           gamedate=clean_asp_date(aline[x])
           gamedate=trim(clean_date(gamedate))
           gameday=get_day(gamedate)
         elsif match("time",mytype[x]) then
           game=game+1
           mytime[game]=clean_asp_time(aline[x])
           mydate[game]=gamedate
           myday[game]=gameday
         elsif match("team",mytype[x]) then
            if sw=0 then --vis team
               sw=1
               vis[game]=clean_team(aline[x]) 
               z=0
                 while not match("longspread",mytype[x+z]) do
                   z=z+1
                     if x+z>length(mytype) then
                      z=z-1
                      exit
                     end if
                      if match("time",mytype[x+z]) then
                          z=z-1
                          exit
                      end if
                 end while
                  if match("longspread",mytype[x+z]) then
                     visspread[game]=clean_spread(aline[x+z])
                  else
                     visspread[game]="NA"
                  end if
            else
               sw=0
               home[game]=upper(clean_team(aline[x]))
                    z=0
                 while not match("longspread",mytype[x+z]) do
                    z=z+1
                    if x+z>length(mytype) then
                      z=z-1
                      exit
                    end if
                      if match("time",mytype[x+z]) then
                         z=z-1
                         exit
                      end if
                 end while
                 if x+z+1>length(mytype) then
                   exit
                 end if
                  if match("longspread",mytype[x+z+1]) or match("shortspread",mytype[x+z+1]) then
                     homespread[game]=clean_spread(aline[x+z+1])
                  else
                     homespread[game]="NA"
                  end if
            end if
       end if
    end while
               ---------------next pass--------------
      year=getyear()
      myweek=get_amain_week_only()
      puts(fn3,"For Week "&myweek& " of Football 20" &year&"\n")
      puts(fn3,last_generated&"\n")
       if game>16 then
         game=16
       end if
        for y=1 to game do
          v=getdec(visspread[y])
          hm=getdec(homespread[y])
          if match("PK",visspread[y]) and hm>0 or match("PK",homespread[y]) and v>19 then
             sprd=homespread[y]
             ou=visspread[y]
             fav=home[y]
             dog=vis[y]
          elsif match("PK",homespread[y]) and v>0 or match("PK",visspread[y]) and hm>19 then
             sprd=visspread[y]
             ou=homespread[y]
             fav=vis[y]
             dog=home[y]
          elsif match("NA",homespread[y]) and v>0 then
             ou=homespread[y]
             sprd=visspread[y]
             fav=home[y]
             dog=vis[y]
          elsif v>hm then
             sprd=homespread[y]
             ou=visspread[y]
             fav=home[y]
             dog=vis[y]
          elsif v<=hm then
             sprd=visspread[y]
             ou=homespread[y]
             fav=vis[y]
             dog=home[y]
          end if
                if fn3>1 then 
                   printf(fn3,"%2d, %5s, %8s ,%6s, %10s, %5s, %5s, %8s,\n",
                         {y,mydate[y],myday[y],mytime[y],fav,sprd,ou,dog}) 
                else
                   printf(1,"%2d %5s %8s %6s %10s %5s %5s %8s\n",
                         {y,mydate[y],myday[y],mytime[y],fav,sprd,ou,dog}) 
                end if
        end for
 end procedure
-- integer answer
-- print_feist(1)
-- answer=question_pause("Save")
 -- if answer=1 then
 -- end if