--spnet NFL 2004
--line 187 & 108 & ytwo up here needs changing each year
constant YR="04"
 global constant WEEK_PATH="c:\\euph_nfl"&YR&"\\alldata.dat"
 --global constant AMAIN_WEEK_PATH="amain.dat"
 --global constant STATS_PATH="c:\\progra~1\\liberty\\NFL"
 --global constant TEAM_PATH="C:\\progra~1\\liberty"
 --integer week
  week=get_amain_week_dec()
        constant OUTPUT_PATH2=sprintf("c:\\progra~1\\liberty\\NFL"&YR&"\\spread%d.dat",week)
        constant OUTPUT_PATH="c:\\progra~1\\liberty\\football\\"
        constant OUTPUT_FILE="trade.dat"
        constant LN=400

 include all.e
 include mydate.e
 --include teams.e

 function open_spnet()
  integer i,fn
  sequence line,week_data
    week_data=get_amain_week()
    fn=my_open("c:\\windows\\spnet"&week_data[1]&".txt","r")
   puts(1,"c:\\windows\\spnet"&week_data[1]&".txt")
      if fn=-1 then 
       puts(1,"in open_spnet() can't open" &"c:\\windows\\spnet"&week_data[1]&".txt")
       abort(0)
      end if
    i=0
   while i=0 do
    line=gets(fn)
    i=match("AS OF",line)
   end while
    close(fn)--reset open after reading dldate
    fn=my_open("c:\\windows\\spnet"&week_data[1]&".txt","r")
  return fn & {"SPNET "&trim(line)}
 end function

 function clean_spread(sequence sprd)
   integer a
   sequence deci
    sprd=sprd[2..length(sprd)]
   a=match(".",sprd)
     if a=0 then
        return sprd
     else 
       deci=sprd[a+1..length(sprd)]
         if getdec(deci)>0 then
             return sprd
         else
            return sprd[1..a-1]
         end if
     end if
 end function

 function clean_spnetdate(sequence mydate)
   sequence myday,week_data
   integer a
    week_data=get_amain_week()
     a=match("- CURRENT",mydate) 
       if a > 0 then 
          mydate=mydate[1..a-1]
       end if
       mydate=trim(mydate)
    a=match(",",mydate)
      myday=mydate[1..a-1]
    a=match("(",mydate)
     mydate=mydate[a+1..length(mydate)-5]&week_data[2]
     mydate=get_short_year(mydate)
   return {mydate} & {myday}
 end function

 function get_spread(integer n,sequence mytype,sequence myitem,sequence sprdtype)
   integer a
    a=n
    while not match(sprdtype,mytype[a]) do
     a=a+1
    end while
       a=a+1
    return  trim(myitem[a])
 end function

 function clean_team(sequence myteam)
   integer a
   a=find(trim(myteam),SPNET_CODE) 
  return MYTEAMS2[a]
 end function

 function get_teams(integer n,sequence mytype,sequence myitem)
  integer a,firsta,seconda
  sequence viz,homey
   a=n
    while not match("team",mytype[a]) do
      a=a+1
    end while
       viz=clean_team(myitem[a])
       firsta=a
        a=a+1
        while not match("team",mytype[a]) do
          a=a+1
        end while
    homey=upper(clean_team(myitem[a]))
    seconda=a
   return {viz} & {homey} & seconda-firsta
 end function

procedure print_heading(integer fn,sequence my_dl_file)
          sequence week_data
    week_data=get_amain_week()
       printf(fn,"For Week %s of Football 2004\n",week_data[1])
      -- printf(fn,"%s %s Generated: %s",{mydir1 , myfile1,generated_date})
--puts(1,"c:\\windows\\spnet"&week_data[1]&".txt\n")
      puts(fn,my_dl_file & "\n")
--puts(1,"*************************************\n")
end procedure

procedure update_db(integer fn,sequence old_db,sequence new_db)
  sequence old_fav_test,new_fav_test,new_dog_test,line
  object a,b
    old_fav_test={}  
    new_fav_test={}
    new_dog_test={}  
   for x= 1 to length(old_db) do --setup test array for old_db
       printf(1,"old_db=%d %s\n",{x,old_db[x][1]})
      line=split(old_db[x],',')
      old_fav_test=append(old_fav_test,trim(line[2])&trim(line[4])&trim(line[5]))
   end for
     for x=1 to length(new_db) do --setup test array for new_db
        line=split(trim(new_db[x]),',')
        new_fav_test=append(new_fav_test,trim(line[2])&trim(line[4])&trim(line[5]))
        new_dog_test=append(new_dog_test,trim(line[2])&trim(line[4])&trim(line[8]))
    end for
    for x= 1 to length(old_db) do
   --  puts(1,">"&old_fav_test[x]&"<     >"&new_fav_test[x]&"<   >"&new_dog_test[x]&"<\n") 
        a=find(old_fav_test[x],new_fav_test)
        b=find(old_fav_test[x],new_dog_test)
         if a=0 and b=0 then  --not found 
             line=split(old_db[x],',')
             line[1]="*"&trim(line[1])
             old_db[x]=reconstruct_line(line)
             puts(fn,old_db[x]&"\n")
         elsif a>0 then --found still the fav
             line=split(old_db[x],',')
             line[1]=sprintf("%3d",x)
             new_db[a]=reconstruct_line(line)--keep the old numbers
             puts(fn,new_db[a]&"\n")
         elsif b>0 then --found fav/dog switched
             line=split(old_db[x],',')
             line[1]=sprintf("%3d",x)
             new_db[b]=reconstruct_line(line)--keep the old numbers
           --  puts(fn,new_db[b]&"**************\n")
         -- puts(1,old_fav_test[x]&"    "&new_fav_test[x]&"\n") 
         end if
    end for
end procedure

function spnet(integer fn2)
  sequence my_dl_file,mytype,myline,spnetdata,gamedate,mydate,myday,mytime,spread,
           nexttype,ou,myteams,spnet_db,home,vis,fav,dog
  object fn,line
  integer linenum,n,sw
    -----------------------
    spnetdata=open_spnet()
    fn=spnetdata[1]
    my_dl_file=spnetdata[2]
     ------------------ 1st pass ----------------------
   --  linenum=50
   --  while 1=1 do
    --   line=gets(fn)
     --    if atom(line) then
     --      exit 
    --     elsif length(trim(line)) > 0 then
       --    linenum=linenum+1
      --   end if
    -- end while
 --  close(fn)
    ---------------------2nd pass---------------------------------
     spnetdata=open_spnet()
     fn=spnetdata[1]
     mytype=repeat({},LN)
     myline={}
     linenum=0
     game=0
   while 1=1 do
       line=gets(fn)
         if atom(line) then
           exit 
         elsif length(trim(line))>0 then
           linenum=linenum+1
           myline=append(myline,line)
      ---------------------date--------------------
             if match("/2004",line) then
             --   puts(1,line)
                mytype[linenum]="date"
             end if
     ----------------------time--------------------
             if match(":",line) and not match("Over/",line) and 
                                  not my_match("As of",line) and
                              not match("CURRENT",line) and
                           not match("Note",line) then 
                    game=game+1
                  mytype[linenum]="time"
     ----------------------rotation----------------
              elsif my_match2("0",line,1) or getdec(line)>60 then
                   mytype[linenum]="rotation"
                  --  puts(1,line)
     ----------------------spread----------------
              elsif my_match("Pick",line) then
                      mytype[linenum]="spread"
              elsif getdec(line) !=0 then 
                   if getdec(line) > 0 then
                      mytype[linenum]="ou"
                   elsif getdec(line) < 0 then
                      mytype[linenum]="spread"
                   end if
            --   puts(1,line)
      -------------------team----------------
              elsif find(trim(line),SPNET_CODE) then
                   mytype[linenum]="team"
              end if
        end if
    end while
   close(fn)
---------------------xtra pass--
 -- for x=1 to 5 do--linenum do
 --printf(1,"%2d mytype[x]=%s myline[x]=%s\n",{x,mytype[x],trim(myline[x])})
--end for
---------------------third pass------------
    mydate=repeat({},game)
    myday=repeat({},game)
    mytime=repeat({},game)
    home=repeat({},game)
    vis=repeat({},game)
    spread=repeat({},game)
    ou=repeat({},game)
    nexttype=repeat({},game)
    fav=repeat({},game)
    dog=repeat({},game)
    gamedate=repeat({},game)
    myteams=dog
     game=0
     n=0
     sw=0
     spnet_db={}
   while n<linenum do
      n=n+1
        if length(trim(myline[n]))>0 then
              if match("date",mytype[n]) then
                  gamedate=clean_spnetdate(myline[n])
              elsif match("time",mytype[n]) then
                    game=game+1
                      mydate[game]=gamedate[1]
                      myday[game]=gamedate[2]
                      mytime[game]=trim(myline[n])
                      spread[game]=get_spread(n,mytype,myline,"spread")
                      ou[game]=get_spread(n,mytype,myline,"ou")
                      myteams[game]=get_teams(n,mytype,myline)
             end if
        end if
   end while 
------------------------4th pass-----main print out---------------
    text_color(WHITE)
     print_heading(fn2,my_dl_file)
      for x= 1 to game do
        spread[x]=clean_spread(spread[x])
        if myteams[x][3] > 2 then
           fav[x]=myteams[x][1]--vis
           dog[x]=myteams[x][2]--home
        else
           fav[x]=myteams[x][2]--home
           dog[x]=myteams[x][1]--vis
        end if--

        mydate[x]=get_short_year(mydate[x])
        spnet_db=append(spnet_db,sprintf("%2d,%s,%8s,%5s,%10s,%5s,%5s,%s,\n",
              {x,mydate[x],myday[x],mytime[x],fav[x],spread[x],ou[x],dog[x]}))
        printf(fn2,"%2d,%s,%9s,%5s,%10s,%5s,%5s,%s,\n",
              {x,mydate[x],myday[x],mytime[x],fav[x],spread[x],ou[x],dog[x]})  
      end for
    return spnet_db
 end function
 
 global procedure spnet_main()
    sequence old_db,new_db,mydir,myfile,spnetdata,my_dl_file
    integer a,answer,fn2,fn3
    clear_screen()
    bk_color(RED)
             mydir=OUTPUT_PATH
             myfile=OUTPUT_FILE
     new_db=spnet(1)--read and print
      answer= overwrite_warning(OUTPUT_PATH2)
 if answer=1 then --normal save
       fn2=my_open(mydir&myfile,"w")
       fn3=my_open(OUTPUT_PATH2,"w")
       new_db=spnet(fn2)--save
       new_db=spnet(fn3)--save
       close(fn2)
       close(fn3)
 elsif answer=3 then--update
 ?9/0
 pause()
     old_db=read_all("spread")
     old_db=old_db[1]
     new_db=spnet(1)--read and print only
      puts(1,"\n>>>>>>>>>>\n")
    spnetdata=open_spnet()
    close(spnetdata[1])
    my_dl_file=spnetdata[2]
         print_heading(1,my_dl_file)
         update_db(1,old_db,new_db)
      puts(1,"  [Return] to Save]     [Esc] to Go Back]")
     while 1=1 do
      a=wait_key() 
       if a=27 then 
              exit
       elsif a=13 then 
       fn2=my_open(mydir&myfile,"w")
       fn3=my_open(OUTPUT_PATH2,"w")
        print_heading(fn2,my_dl_file)
        print_heading(fn3,my_dl_file)
              update_db(fn2,old_db,new_db)
              update_db(fn3,old_db,new_db)
         close(fn2)
         close(fn3)
         exit
       end if
      end while
elsif answer=2 then--do nothing
end if
 end procedure
