--sumup.e NFL 2003 version
   with trace

 include myInclude\mygets.e as mg
 include myInclude\strlist.e as sl

   global function read_totals(sequence file) --read grand runing totals
     object line,myline ,fn    --started with week 21 2002
     sequence numpicks,numcor
     integer y
     numpicks=repeat({},length(SOURCE))
     numcor=repeat({},length(SOURCE))
      fn=my_open(file,"r")
     for x=1 to 3 do  --kill first three lines
       line=gets(fn)
     end for
       y=0
      while 1=1 do
        line=gets(fn)
         if sequence(line) then 
           y=y+1
           line=mg:trim(line)
           myline=sl:split(line,',')
           numpicks[y]=myline[3]
           numcor[y]=myline[4]
         else 
           exit
         end if
      end while
      close(fn)
     return {numpicks} & {numcor}
    end function

   global function read_sumup(sequence week)--read this weeks sumup--
        sequence db,newpicks,newcor,fileName,winyear
        integer fn
     if platform()=WIN32 then
         winyear=getText(YEAR)
         winyear=winyear[3..4]
         fileName=STATS_PATH & winyear&"\\conre"&week&".dat"
     else
         fileName=STATS_PATH & yr[year_pos]&"\\conre"&week&".dat"
     end if
      fn=my_open(fileName,"r")
        if fn=-1 then 
          puts(1," in read_sumup() couldn't read>"&fileName&"\n")
          abort(0)
        else
           db=get(fn)
           db=db[2]
         --  db=db[1]
           newpicks=db[1]
           newcor=db[2]
        end if
      close(fn)
     return {newpicks} & {newcor}
   end function

procedure print_sumup(sequence totpicks,sequence totcor,sequence newpicks,
                      sequence newcor,sequence newtotpicks,sequence newtotcor,
                      sequence newtotwrong,sequence percent,integer limit)
   integer a,b,c,d,oddeven,first    -------formerly second print out----------
   sequence tc
    if limit>12 then
      first=12
    else
      first=limit
    end if
   tc={BRIGHT_WHITE,8}
     a=1--picks
     b=9--correct
     c=6--wrong
     d=11--headings
     clear_screen()
     text_color(d)
       puts(1,"         Last    \n")    --------------------heading------------------
       puts(1,"         Year    " )

        for x=1 to first do
           text_color(tc[get_oddeven(x)])
           printf(1,"%2d  ",x)--week number
        end for
          text_color(d)
          puts(1,"\n         Pk Cor")
         for x=1 to first do
           text_color(tc[get_oddeven(x)])
           puts(1," W_k")
         end for
    --  text_color(d)
    --  puts(1," New Totals")
      puts(1,"\n")
      for x=1 to length(SOURCE) do
         text_color(d)
         printf(1,"%9s",{SOURCE[x]})
         text_color(a)
         printf(1,"%3s",{totpicks[x]})
         text_color(b)
         printf(1,"%3s",{totcor[x]})
                    for y=1 to first do
                         oddeven=get_oddeven(y)
                         text_color(tc[oddeven])
                        printf(1,"%2d",newpicks[y][x])
                         text_color(tc[oddeven])
                        printf(1,"%2d",{newcor[y][x]})
                    end for
               text_color(YELLOW)
         percent[x]=get_percent(newtotcor[x],newtotpicks[x])
              
         --     printf(1," %2d%%",{percent(newcor[first][x],newpicks[first][x])})
        puts(1," ")
        text_color(a)
  --      printf(1,"%3d",{newtotpicks[x]})
        text_color(b)
       -- printf(1," %3d",{newtotcor[x]})
        text_color(c)
     --  printf(1," %3d",{newtotwrong[x]})
        text_color(YELLOW)
    --    printf(1," %3d%%\n",percent[x])
        puts(1,"\n")
      end for
 ---------------------------the second half---------------------------
      puts(1,"                 ")

       puts(1,"\n")

-----------------------------------------------
    if limit>12 then
        puts(1,"                 ")
        for x=12 to limit do
           text_color(tc[get_oddeven(x)])
           printf(1,"%2d  ",x)--week number
        end for

      puts(1,"\n")
      for x=1 to length(SOURCE) do
         text_color(d)
         printf(1,"%9s",{SOURCE[x]})
         text_color(a)
         printf(1,"%3s",{totpicks[x]})
         text_color(b)
         printf(1,"%3s",{totcor[x]})
                    for y=12 to limit do
                         oddeven=get_oddeven(y)
                         text_color(tc[oddeven])
                        printf(1,"%2d",newpicks[y][x])
                         text_color(tc[oddeven])
                        printf(1,"%2d",{newcor[y][x]})
                    end for
        puts(1," ")
        text_color(a)
        printf(1,"%3d",{newtotpicks[x]})
        text_color(b)
        printf(1," %3d",{newtotcor[x]})
        text_color(c)
        printf(1," %3d",{newtotwrong[x]})
        text_color(YELLOW)
        printf(1," %3d%%\n",percent[x])
      end for
   end if
 ----------------------------
   -- for x=1 to length(SOURCE) do
      --  text_color(a)
     --   printf(1,"%3d",{newtotpicks[x]})
       -- text_color(b)
       -- printf(1," %3d",{newtotcor[x]})
       -- text_color(c)
       -- printf(1," %3d",{newtotwrong[x]})
       -- text_color(YELLOW)
        --printf(1," %3d%%\n",percent[x])
    --end for
 ----------------------------
     text_color(a)
     puts(1,"\n Total Picks ")--color legend
     text_color(b)
     puts(1," Total Correct ") 
     text_color(c)
     puts(1," Total Wrong\n")
    ----------------------------
     --  gPuts(1,70,"Last")
    --   gPuts(2,70,"Weeks")
    --   gPuts(3,70,"%")
    ----------------------totals---------------
     
    for x=1 to length(SOURCE) do
      text_color(d)
  --   gPuts(16+x,54,SOURCE[x])
      text_color(a)
  --   gPuts(16+x,64,sprintf("%3d",{newtotpicks[x]}))
      text_color(b)
  --   gPuts(16+x,67,sprintf(" %3d",{newtotcor[x]}))
      text_color(c)
   --  gPuts(16+x,71,sprintf(" %3d",{newtotwrong[x]}))
      text_color(YELLOW)
   --  gPuts(16+x,75,sprintf(" %3d%%\n",percent[x]))
    end for
  --   gPuts(28,20,"")
end procedure--print_sumup()

 global procedure sumup(integer sw,sequence week)
   sequence tot,new,totpicks,totcor,newpicks,newcor,newtotpicks,newtotcor,
            percent,newtotwrong,winyear
   integer a,limit
   object fn,fn2
trace(3)
    newtotpicks=repeat(0,length(SOURCE))
    newtotcor=repeat(0,length(SOURCE))
    percent=repeat({},length(SOURCE))
    newtotwrong=repeat({},length(SOURCE))
    newpicks=repeat({},length(SOURCE))
    newpicks=repeat(newpicks,22)
    newcor=repeat({},length(SOURCE))
    newcor=repeat(newcor,22)
    tot=read_totals(LAST_YR_SUMUP)--the  sumup totals
 --   tot=repeat({},length(SOURCE))
    totpicks=tot[1]
    totcor=tot[2]
     if sw=1 then
         limit=getdec(week)
     elsif sw=0 then
         limit=getdec(week)-1
     end if
   for x=1 to limit do
       new=read_sumup(sprintf("%d",x))--the weekly conre
         for y=1 to length(newpicks[x]) do
            if length(new[1])<y then--in case we added new sources
               newpicks[x][y]=0
               newcor[x][y]=0
            else
               newpicks[x][y]=new[1][y]
               newcor[x][y]=new[2][y]
            end if
         end for
   end for
      ------------------------calculate body-----------------------
                for x=1 to length(SOURCE) do
                               newtotwrong[x]=newtotpicks[x]-newtotcor[x]
                               newtotpicks[x]=getdec(totpicks[x])  
                               newtotcor[x]=getdec(totcor[x])
                               newtotwrong[x]=newtotpicks[x]-newtotcor[x]
                    for y=1 to limit do
                        newtotpicks[x]=newtotpicks[x]+newpicks[y][x]
                        newtotcor[x]=newtotcor[x]+newcor[y][x]
                        newtotwrong[x]=newtotwrong[x]+newpicks[y][x]-newcor[y][x]
                    end for
                 percent[x]=get_percent(newtotcor[x],newtotpicks[x])
             end for
  if sw=1 then
      bk_color(RED)
     print_sumup(totpicks,totcor,newpicks,newcor,newtotpicks,newtotcor,newtotwrong,percent,limit)
              -----------------------save ------------------
     a=question_pause("Save")

     if a=1 then
       fn=open(SUMUP_PATH,"w")
        if platform()=WIN32 then
           winyear=getText(YEAR)
           winyear=winyear[3..4]
           fn2=open(STATS_PATH&winyear&"\\sumup"&week&".dat","w")
        else
           fn2=open(STATS_PATH&yr[year_pos]&"\\sumup"&week&".dat","w")
        end if
          puts(fn,"week="&week)
          puts(fn,"\n\nitem\n")
          puts(fn2,"week="&week)
          puts(fn2,"\n\nitem\n")
               for x=1 to length(SOURCE) do
                    printf(fn,"%13s,%4d ,%4d ,%4d ,%4d,\n",
                          {SOURCE[x],percent[x],newtotpicks[x],
                           newtotcor[x],newtotwrong[x]})
                    printf(fn2,"%13s,%4d ,%4d ,%4d ,%4d,\n",
                          {SOURCE[x],percent[x],newtotpicks[x],
                           newtotcor[x],newtotwrong[x]})
                end for
        close(fn)
        close(fn2)
     end if
  else
   bk_color(3)   ------- print out----------
   print_sumup(totpicks,totcor,newpicks,newcor,newtotpicks,newtotcor,newtotwrong,percent,limit)
   text_color(8)
   pause()
  end if
 end procedure--sumup(integer sw,sequence week)


 global procedure fix_sumup()
  object fn,line
   file_id=open(SUMUP_PATH,"r")
   fn=open("temp.dat","w")
   for x=1 to length(SOURCE)+3 do
     line=gets(file_id)
      if atom(line) then
       line=sprintf("%13s,%4d ,%4d ,%4d ,%4d,\n",{SOURCE[x-3],0,0,0,0})
      -- line=sprintf("%13s,%4d,0,0,0,\n",{SOURCE[x-3],0})
      end if
    puts(fn,line)
   end for
   close(file_id)
   close(fn)
   system(sprintf("copy temp.dat %s",{SUMUP_PATH}),0) 
cursor(NO_CURSOR)
 end procedure

 global procedure check_sumup()
    object nextline
    integer x
     x=0
     nextline={}
     file_id=open(SUMUP_PATH,"r")
       if file_id=-1 then
           puts(1,"CAN'T OPEN FILE "&SUMUP_PATH)
       end if
    while sequence(nextline) do
       nextline=gets(file_id)
       x=x+1
    end while
     close(file_id)
     if length(SOURCE)>x-4 then
       fix_sumup()
     end if
 end procedure



