--
-- eaini.e
--
include ini.e as ini    -- NOT part of arwen, using a copy of the MEditor one
--with trace
--integer flag

function mini(sequence Name, integer Type, object Default)
    ini:defineIniHeading(Name, Type)
    return ini:getIniValue(Name,Default)
end function

--integer once
--      once=1
--
--procedure oops()
--  if once then
--      void=messageBox("Warning","corrupt cursor info in .ini file",0)
--      once=0  -- don't output same message 30 times
--  end if
--end procedure

function by7(sequence text)
-- convert sprint sequence into 7 (non-negative) digits, and ,0,0}
integer i,c,ci,n
sequence res
    if text[1]='{' then
        i=1
        ci=2
        n=0
        res=repeat(0,9)
        while 1 do
            c=text[ci]
            if c>='0' and c<='9' then
                n=n*10+c-'0'
            elsif c=',' then
                res[i]=n
                i+=1
                if i>7 then exit end if
                n=0
            elsif c='}' then
                if i!=7 then exit end if
                res[i]=n
                return res
            end if
            ci+=1
            if ci>length(text) then exit end if
        end while
    end if
--  oops()
    return repeat(0,9)
end function

procedure addTool(sequence tool)
    if not find(tool,isToolSet) then
        isToolSet=append(isToolSet,tool)
    end if
end procedure

global integer newcurrfile

integer wasDebug

--with trace
procedure loadINI()
sequence prevfiles, prevcursel
integer wasNewIni, lendiff
sequence cl
atom tcStyle
    wasNewIni=isNewIni()

    ini:defineIniGroup("Main")
    isDebug                 = mini("debug", BOOL, False)
    wasDebug=isDebug
    checkSingleInstance()
    isFaceName              = mini("Face Name", TEXT, "ANSI_FIXED_FONT")
    isPointSize             = mini("Font Tenths", INT, 100)/10
    isWindowPos             = mini("Window Position", SEQ, {20, 20})
    isWindowRect            = mini("Window Size", SEQ, {500, 380})
    void=c_func(xMoveWindow, {mainHwnd, isWindowPos[1], isWindowPos[2],
                                        isWindowRect[1],isWindowRect[2], 1})
    isWindowMaximised       = mini("Window Maximized", BOOL, False)

    isShowFullPath          = mini("Show Full Path", BOOL, True)
    isWindowMenu            = mini("Window Menu", INT, 4)
    isToolBarVIS            = mini("Tool Bar Visible", BOOL, True)
--  setVisible(TB,isToolBarVIS)
--  if isToolBarVIS then toggleToolBar() end if -- moved to eamenus.ew
    isTabBarVIS             = mini("Tab Bar Visible", BOOL, True)
    isSingleDir             = mini("Single Dir Tabbar", BOOL, False)
    isMultiLineTab          = mini("Multi Line Tab", BOOL, True)
    if not isMultiLineTab then
--  TC = create(TabControl, "" , 0, Main, 0,0,372,122,TCS_MULTILINE)
--  else
--  TC = create(TabControl, "" , 0, Main, 0,0,372,122,0) --(TCS_MULTILINE*isMultiLineTab))
        tcStyle=c_func(xGetWindowLong, {TChwnd, GWL_STYLE})
--      tcStyle=or_bits(tcStyle,TCS_MULTILINE)
        tcStyle-=and_bits(tcStyle,TCS_MULTILINE)
        void = c_func(xSetWindowLong, {TChwnd, GWL_STYLE, tcStyle } )
    end if
    isFilePanelVIS          = mini("File Panel Visible", BOOL, False)
    setVisible(TV,isFilePanelVIS)
--  setVisible(FP,isFilePanelVIS)
    isFilePanelWidth        = mini("File Panel Width", INT, 275)
    isMessageVIS            = mini("Message Area Visible", BOOL, False)
    setVisible(MA,isMessageVIS)
    isMessageHeight         = mini("Message Area Height", INT, 100)
    isHScrollVIS            = mini("Horizontal Scroll Bar", BOOL, True)
    isVScrollVIS            = mini("Vertical Scroll Bar", BOOL, True)
--  setVisible(HHH,isHScrollVIS)
--  setVisible(VVV,isVScrollVIS)
    isMoveCursorOnScroll    = mini("Move Cursor On Scroll", BOOL, False)
    isScrollPerm            = mini("Permanent Scrollbars", BOOL, False)
    isLineNumbers           = mini("Line Numbers", BOOL, False)
    isFoldMarginPerm        = mini("Permanent Fold Margin", BOOL, False)
    marginRqd = isFoldMarginPerm
    isStatusBar             = mini("Status Bar", BOOL, True)
    setVisible(SB,isStatusBar)
    isWordWrap              = mini("Word wrap", BOOL, True)
    isWordWrapCol           = mini("Word wrap column", INT, 80)
    isFormatExErr           = mini("Reformat ex.err", BOOL, True)
    isSingleInstance        = mini("Single Instance", BOOL, True)
    isRestoreOnOpen         = mini("Restore Files On Open", BOOL, True)
    isAutoSaveOnExit        = mini("Auto Save Files On Exit", BOOL, False)
    isAutoSaveOnTabSwitch   = mini("Auto Save On Tab Switch", BOOL, False)
    isAutoSaveTimer         = mini("Auto Save every nnn seconds", INT, 0)
    isAutoBackup            = mini("Automatic Backup", BOOL, True)
    isRetainBackupsFor      = mini("Retain backups for", INT, 2)
    isLoadErrFileOnError    = mini("Load ex.err on error", BOOL, False)
    isReplaceTabs           = mini("Replace Tabs With Spaces", BOOL, True)
    isTabWidth              = mini("Tab Spacing", INT, 4)
    initT() -- now isTabWidth is known
    isHomeFirstNonBlank     = mini("Home jumps to first non-blank character", BOOL, True)
    mouseWheelScroll        = mini("mouseWheelScroll", INT, 5)
    isCaretBlinkTime        = mini("Caret Blink Time", INT, 250)
    void=c_func(xSetCaretBlinkTime,{isCaretBlinkTime})
--  isLineLengthError       = mini("Show Line Length Errors", BOOL, False)
    isUndoTime              = mini("Retain undo for nn seconds", INT, 3600)
    isAutoComplete          = mini("Autocompletion", INT, True)
    isBackGround            = mini("Background Processing", INT, True)
    isCurrProject           = mini("Current Project", INT, 0)   --DEV unused
    isClearOverStrike       = mini("ClearOverStrike", INT, #0C) -- default is file and page
    crashpath               = mini("mostRecentErrorPath", TEXT, initialcurrentdir)

--  ini:defineIniHeading("singleInstance", BOOL)
--  singleInstance = getIniValue("singleInstance",True)
--  ini:defineIniHeading("AutoSaveSeconds", INT)
--  AutoSaveSeconds = getIniValue("AutoSaveSeconds", 0)
--  if AutoSaveSeconds then
--      setTimer( STATUSBAR, AutoSaveInterrupt, AutoSaveSeconds*1000) 
--  end if
--  setTimer(STATUSBAR,TimeUpdate,60000)
--
--  ini:defineIniHeading("isAutoCompletion", BOOL)
--  isAutoCompletion = getIniValue("isAutoCompletion", False)
--  ini:defineIniHeading("win32libs_exh_Size", INT)
--  ini:defineIniHeading("glocals_exh_Size", INT)
--
    newcurrfile             = mini( "currfile", INT, 0)

    ini:defineIniGroup("tools")
    isToolSet=ini:getIniTextValues()
--DEV: (use the version no?)
    addTool("Database Viewer:tedb")
    addTool("Verify edita.edb:vedb")

if isDebug=False then
    ini:defineIniGroup("previous session")
    prevfiles=ini:getIniTextValues()
    ini:defineIniGroup("session cursel")
    prevcursel=ini:getIniTextValues()

    if wasNewIni and length(prevfiles)=0 then
--      prevfiles = command_line()
--      prevfiles = prevfiles[2..2]
--      for i = length(prevfiles[1]) to 1 by -1 do
--          if prevfiles[1][i]='\\' then
--              prevfiles[1]=prevfiles[1][1..i]&"readme.txt"    --DEV or what?
--              exit
--          end if
--      end for
        prevfiles={initialcurrentdir&"welcome.txt"}
    end if
else
--DEV
--  prevfiles={initialcurrentdir&"a.exw"}
--  prevfiles={initialcurrentdir&"demo_lists.exw"}
--  prevfiles={initialcurrentdir&"aa.asm"}
--  prevfiles={initialcurrentdir&"test7.exw"}
--  prevfiles={initialcurrentdir&"test2.e"}
--  prevfiles={initialcurrentdir&"edita.exw"}
    prevfiles={initialcurrentdir&"test.exw"}
--  prevfiles={initialcurrentdir&"test.htm"}
--  prevfiles={initialcurrentdir&"doc\\t.htm"}
    prevcursel=""
end if
    cl=command_line()
    if length(cl)>2 then
        prevfiles &= cl[3..length(cl)]
        newcurrfile = length(prevfiles)
    end if

    lendiff = length(prevfiles) - length(prevcursel)
    if lendiff > 0 then
        prevcursel&=repeat("*",lendiff)
    elsif lendiff < 0 then
        prevcursel=prevcursel[1..length(prevfiles)]
    end if

    for i = 1 to length(prevfiles) do
        currfile=0
--if i=length(prevfiles) then trace(1) end if
        if openFile({prevfiles[i]}) then
            filecursel[currfile] = by7(prevcursel[i])
            restcursel()
            --
            -- and ensure all cursors etc are in range
            --
            if CursorY>length(filetext[currfile])-1
            or CursorX>ExpLength(filetext[currfile][CursorY+1])
            or TopLine>CursorY  -- might be OK, but be safe
            or Column>CursorX   -- might be OK, but be safe
            or (selON and selY>length(filetext[currfile])-1)
            or (selON and selX>ExpLength(filetext[currfile][selY+1])) then
--          flag = 0
--          if CursorY>length(filetext[currfile])-1 then
--trace(1)
--              flag = 1
--          end if
--          if CursorX>ExpLength(filetext[currfile][CursorY+1]) then
--trace(1)
--          CursorX=ExpLength(filetext[currfile][CursorY+1])
--              flag = 1
--          end if
--          if TopLine>CursorY then
--trace(1)
--              flag = 1
--          end if
--          if Column>CursorX then
--trace(1)
--              flag = 1
--          end if
--          if (selON and selY>length(filetext[currfile])-1) then
--trace(1)
--              flag = 1
--          end if
--          if (selON and selX>ExpLength(filetext[currfile][selY+1])) then
--trace(1)
--              flag = 1
--          end if
--          if flag then
--              oops()  -- more annoying than helpful!
                CursorX=0
                CursorY=0
                TopLine=0
                Column=0
                selON=0
                savecursel()
            end if
        end if
    end for
--end if
    if newcurrfile>length(filecursel) then
        newcurrfile=length(filecursel)
    end if
end procedure

loadINI()


global procedure saveINI()  -- can be called many times. [???]
integer newcf
    if currfile then
        filecursel[currfile]={CursorX,CursorY,TopLine,Column,selON,selX,selY,0,0}
    end if
    switchToIniGroup("Main")
    setIniValue("debug", wasDebug)  --NB saveINI() won't be called if isDebug is True;
                                    -- we use wasDebug, not isDebug here because debug
                                    -- mode is automatically switched off if another
                                    -- instance of edita is not running (see easinst.e)
    setIniValue("Face Name", isFaceName)
    setIniValue("Font Tenths", floor(isPointSize*10+0.5))
    setIniValue("Window Position", isWindowPos)
    setIniValue("Window Size", isWindowRect)
    setIniValue("Window Maximized", isWindowMaximized(Main))

    setIniValue("Show Full Path", isShowFullPath)
    setIniValue("Window Menu", isWindowMenu)
    setIniValue("Tool Bar Visible", isToolBarVIS)
    setIniValue("Tab Bar Visible", isTabBarVIS)
    setIniValue("Single Dir Tabbar", isSingleDir)
    setIniValue("Multi Line Tab", isMultiLineTab)
    setIniValue("File Panel Visible", isFilePanelVIS=1) -- 2 if opened via Ctrl Q
    setIniValue("File Panel Width", isFilePanelWidth)
    setIniValue("Message Area Visible", isMessageVIS=1) -- 2 if opened via F5
    setIniValue("Message Area Height", isMessageHeight)
    setIniValue("Horizontal Scroll Bar", isHScrollVIS)
    setIniValue("Vertical Scroll Bar", isVScrollVIS)
    setIniValue("Move Cursor On Scroll", isMoveCursorOnScroll)
    setIniValue("Permanent Scrollbars", isScrollPerm)
    setIniValue("Line Numbers", isLineNumbers)
    setIniValue("Permanent Fold Margin", isFoldMarginPerm)
    setIniValue("Status Bar", isStatusBar)
    setIniValue("Word wrap", isWordWrap)
    setIniValue("Word wrap column", isWordWrapCol)
    setIniValue("Reformat ex.err", isFormatExErr)
    setIniValue("Single Instance", isSingleInstance)
    setIniValue("Restore Files On Open", isRestoreOnOpen)
    setIniValue("Auto Save Files On Exit", isAutoSaveOnExit)
    setIniValue("Auto Save On Tab Switch", isAutoSaveOnTabSwitch)
    setIniValue("Auto Save every nnn seconds", isAutoSaveTimer)
    setIniValue("Automatic Backup", isAutoBackup)
    setIniValue("Retain backups for", isRetainBackupsFor)
    setIniValue("Load ex.err on error", isLoadErrFileOnError)
    setIniValue("Replace Tabs With Spaces", isReplaceTabs)
    setIniValue("Tab Spacing", isTabWidth)
    setIniValue("Home jumps to first non-blank character", isHomeFirstNonBlank)
    setIniValue("mouseWheelScroll", mouseWheelScroll)
    setIniValue("Caret Blink Time", isCaretBlinkTime)
--  setIniValue("Show Line Length Errors", isLineLengthError)
    setIniValue("Retain undo for nn seconds", isUndoTime)
    setIniValue("Autocompletion",isAutoComplete)
    setIniValue("Background Processing",isBackGround)
    setIniValue("Current Project", isCurrProject)
    setIniValue("ClearOverStrike", isClearOverStrike)
    setIniValue("mostRecentErrorPath", crashpath)

--      setIniValue("isRestoreFilesOnOpen", isRestoreOnOpen)
--      setIniValue("isAutoSaveFilesOnExit", isAutoSaveOnExit)
--      setIniValue("singleInstance", singleInstance)
--      setIniValue("AutoSaveSeconds", AutoSaveSeconds)
--      setIniValue("isAutoCompletion", isAutoCompletion)
--
    --
    -- save any modified files
    --

    -- this should not have changed, but make sure it is not discarded.
    switchToIniGroup("tools")
    for i=1 to length(isToolSet) do
        setIniTextValue(isToolSet[i])
    end for

    --
    -- save the edit session
    --
    if isRestoreOnOpen then
        newcf=currfile
        --DEV presumably don't do this unless we are about to close.
        for i = length(filecursel) to 1 by -1 do
            if find(filenames[i],{"ex.err"}) -- oft open, not worth saving file
            or match(untitled,filenames[i])=1 then -- user chose not to save
                filepaths=filepaths[1..i-1]&filepaths[i+1..length(filepaths)]
                filenames=filenames[1..i-1]&filenames[i+1..length(filenames)]
                filecursel=filecursel[1..i-1]&filecursel[i+1..length(filecursel)]
                if newcf>=i then
                    newcf-=1
                end if
            end if
        end for
        switchToIniGroup("Main")
        setIniValue("currfile", newcf)
        switchToIniGroup("previous session")
        for i = 1 to length(filecursel) do
            setIniTextValue(filepaths[i]&filenames[i])
        end for
        switchToIniGroup("session cursel")
        for i = 1 to length(filecursel) do
            setIniTextValue(sprint(filecursel[i][1..7]))
        end for
    end if

    saveIniToDisk()

end procedure
