-- keys.e
-- defines keystrokes for various platforms

global atom
    UP, DOWN, LEFT, RIGHT, ESC, ENTER, BACKSPACE, TAB, DELETE, HOME, KEND,
    F1, F2, F3, F4, F5, F6, F7, F8, F9, F10, F11, F12, PGUP, PGDN, INSERT, SPACE

-- common to all platforms
SPACE = ' '
TAB = '\t'
ESC = 27

if platform() = 3 then
    DOWN = 258
    UP = 259
    LEFT = 260
    RIGHT = 261
    ENTER = 10
    BACKSPACE = 263
    DELETE = 330
    F1 = 265
    F2 = 266
    F3 = 267
    F4 = 268
    F5 = 269
    F6 = 270
    F7 = 271
    F8 = 272
    F9 = 273
    F10 = 274
    F11 = 275
    F12 = 276
    HOME = 262
    KEND = 360
    PGUP = 339
    PGDN = 338
    INSERT = 331
else
    DOWN = 336
    UP = 328
    LEFT = 331
    RIGHT = 333
    ENTER = 13
    BACKSPACE = 8
    DELETE = 339
        F1 = 315
        F2 = 316
        F3 = 317
        F4 = 318
        F5 = 319
    F6 = 320
    F7 = 321
    F8 = 322
    F9 = 323
    F10 = 324
    F11 = 325
    F12 = 326
    HOME = 327
    KEND = 335
    PGUP = 329
    PGDN = 337
    INSERT = 338
end if

global constant
    KEY_BUFFER = 1054,   -- keyboard buffer; circular queue
    FIRST_INDEX = 1050,  -- index to first key in buffer
    LAST_INDEX = 1052    -- index to last key in buffer

-- buffer is empty is indexes point to each other
if peek( FIRST_INDEX ) = peek( LAST_INDEX ) then
-- nothing in the buffer
end if

constant
SCAN_CODE = peek( KEY_BUFFER + peek( FIRST_INDEX ) - 29 ),
KEY_CODE = peek( KEY_BUFFER + peek( FIRST_INDEX ) - 30 )

-- clear the buffer
poke( FIRST_INDEX, peek( LAST_INDEX ) )
-----
