include mydate.e
global atom t0,loop_overhead
global sequence now,mytext,setresult
global integer status,p,row,mylog_file_id
global constant ITERATIONS = 100000 --original 1000000 

global function log_gettime()
  sequence tm,now
  now=date()
  tm=sprintf("%02d:%02d:%02d",{now[4],now[5],now[6]})
  return tm
end function

global function log_getdate()
   sequence now,md
   now = date()
   md=sprintf("%02d/%02d/%02d\n",{now[2],now[3],now[1]-100})
   md=md[1..length(md)-1]
  return md
end function

global procedure clearlog()
sequence mydate,mytime,trade_path1
trade_path1="mylog.txt"
mylog_file_id=open(trade_path1,"w")
now=date()

puts(mylog_file_id,"*********************\n")
puts(mylog_file_id,"*********************\n")
puts(mylog_file_id,"Created by Don Cole\n")
printf(mylog_file_id,"    Year=%d\n",{now[1]+1900})
  mydate=log_getdate()
  mytime=log_gettime()
  printf(mylog_file_id,"  %s   %s\n",{mydate,mytime})
--printf(mylog_file_id,"decyear=%d\n",{decyear})
--printf(mylog_file_id,"since_year%d\n",{since_year})
--printf(file_id,"Year=%d\n",{now[1]+since_year})
--printf(file_id,"Month=%d\n",{now[2]})
--printf(file_id,"day=%d\n",{now[3]})
--printf(file_id,"hour=%d\n",{now[4]})
--printf(file_id,"Min=%d\n",{now[5]})
--printf(file_id,"Second=%d\n",{now[6]})
--puts(file_id,"*********************\n")
--printf(mylog_file_id,"%02d:%d:%d  %d/%d/%d\n",{now[4],now[5],now[6],now[2],now[3],now[1]+2000})
puts(mylog_file_id,"*********************\n")
close (mylog_file_id)
end procedure

global procedure notelog(sequence text)
  sequence mytime
  mylog_file_id=open("mylog.txt","a")
  now=date()
  mytime=sprintf("%02d:%02d:%02d",{now[4],now[5],now[6]})
  mytime=get_mil_to_standard(mytime)
--  printf(mylog_file_id,"%-40s     %02d:%02d:%02d\n",{text,now[4],now[5],now[6]})
  printf(mylog_file_id,"%-40s     %s\n",{text,mytime})
  close (mylog_file_id)
end procedure

global procedure run_db(sequence db)
  for x=1 to length(db) do
     notelog(sprintf("*%d %s",{x,db[x]}))
  end for
end procedure

global procedure ml_test(object totest,sequence var_name)
   if atom(totest) then
        notelog(sprintf("*%s=%d",{var_name,totest}))
   elsif sequence(totest) then
        notelog(sprintf("*length(%s)=%d",{var_name,length(totest)}) )
   end if
end procedure

global procedure special(sequence movnum,integer dbnum,sequence index)  
  integer a
   a=find(movnum,index[dbnum])
    ml_test(movnum,"movnum")
    ml_test(dbnum,"dbnum")
    ml_test(index,"index")
 notelog(sprintf(" movnum %s was found at %d in index[%d]",{movnum,a,dbnum}))
    if a=0 then 
      run_db(index[dbnum])
      ?9/0
    end if
end procedure

