--include win32lib.ew
  include mywin.ew
  include math.e
  include mydate.e
  constant FONT="Courier New"
  constant PRINTER_FONT_SIZE=10,PAPER_FONT_SIZE=5
  integer   charsPerLine, linesPerPage

  sequence  fontSize, printerSize,stuff
  integer scrH,scrW,paper,paper_height,paper_width
  integer papCharsPerLine,papLinesPerPage
  sequence papFontSize,papSize
  constant PrWin     = create(Window,"Printer Window 1",
                           Window1,20,20,800,600,{ #CC0000 } ),
     PushButton6 = createEx( PushButton, "Close", PrWin, 150, 452, 88, 28, 0, 0 ),
       SB2 = createEx( StatusBar, "StatusBar4", PrWin, 0, 0, 0, 0, 0, 0 )

procedure get_info2()--get info on paper window
  setFont( paper,FONT, PAPER_FONT_SIZE, Normal )
  papFontSize=getFontSize( paper)
  papSize= getCtlSize( paper)
  papCharsPerLine = floor(papSize[1]/papFontSize[1])
  papLinesPerPage = floor(papSize[2]/papFontSize[2])
    mPuts(PrWin,10,320,sprintf("PAPER using the %s size %d font.",{FONT,PAPER_FONT_SIZE}))
    mPuts(PrWin,10,340,"character width = " & sprintf("%d",papFontSize[1]))
    mPuts(PrWin,10,360,"character height = " & sprintf("%d",papFontSize[2]))
  setTextColor(PrWin,Red)
    mPuts(PrWin,10,380,"characters per line = " & sprintf("%d",papCharsPerLine))
    mPuts(PrWin,10,400,"lines per page = " & sprintf("%d",papLinesPerPage))
end procedure

 global function get_printer_info()--printer
   integer prtW,prtH,prtFontH,prtFontW
if length(getPrinter()) > 0 then--open the printer dialog--then, IF the user has selected a printer...
  openWindow(PrWin,0)-- print preview window
  setFont( Printer, FONT, PRINTER_FONT_SIZE, Normal )  -- pick a big fixed width font
  fontSize = getFontSize( Printer )  -- get the font metrics
  printerSize = getCtlSize( Printer )  -- get the size of a printer page
  charsPerLine = floor(printerSize[1]/fontSize[1])-- how many characters can fit on a line?
  linesPerPage = floor(printerSize[2]/fontSize[2])  -- how many lines can fit on a page?
 prtW=printerSize[1]
 prtH=printerSize[2]
 prtFontW=fontSize[1]
 prtFontH=fontSize[2]
-- report all the printer's 'metrics'
setPenPos(PrWin,10,10)
  wPuts(PrWin,sprintf("PRINTER using the %s size %d font.",{FONT,PRINTER_FONT_SIZE}))
setPenPos(PrWin,10,30)
wPuts(PrWin,"character width = " & sprintf("%d",fontSize[1]))
setPenPos(PrWin,10,50)
wPuts(PrWin,"character height = " & sprintf("%d",fontSize[2]))
setPenPos(PrWin,10,70)
setTextColor(PrWin,Red)
wPuts(PrWin,"characters per line = " & sprintf("%d",charsPerLine))
setPenPos(PrWin,10,90)
wPuts(PrWin,"lines per page = " & sprintf("%d",linesPerPage))
setTextColor(PrWin,Black)
setPenPos(PrWin,10,120)
wPuts(PrWin,"SIZE page 'pixel' width = " & sprintf("%d",printerSize[1]))
setPenPos(PrWin,10,140)
wPuts(PrWin,"SIZE page 'pixel' height = " & sprintf("%d",printerSize[2]))
-- and screensize
  scrW = w32Func( xGetSystemMetrics,{SM_CXSCREEN})--screensize i added
  scrH = w32Func( xGetSystemMetrics,{SM_CYSCREEN})
setPenPos(PrWin,10,160)
wPuts(PrWin,"Screen 'pixel' width = " & sprintf("%d",scrW))
setPenPos(PrWin,10,180)
wPuts(PrWin,"Screen 'pixel' height = " & sprintf("%d",scrH))
    stuff=get_asp(scrW,scrH)
setPenPos(PrWin,10,260)
wPuts(PrWin,"Screen aspect ratio = " & sprintf("w=%d h=%d",{stuff[1],stuff[2]}))
    stuff=get_asp(prtW,prtH)
    paper_width=stuff[1]
    paper_height=stuff[2]
setPenPos(PrWin,10,280)
wPuts(PrWin,"Paper aspect ratio = " & sprintf("w=%d h=%d",{stuff[1],stuff[2]}))
 return paper_width & paper_height & printerSize[2] & prtFontW & prtFontH
else
 setText(SB,"No Printer Selected...")
 setFocus(Window1)
 return-1
end if
end  function

procedure drawPaper(integer paper_width,integer paper_height)--create paper window
  paper = createEx( Window, "", PrWin,  250, 30,  paper_width*4, paper_height*4, {WS_POPUP, WS_THICKFRAME}, 0 )
  setWindowBackColor(paper,BrightWhite)
end procedure

function read_text(sequence data)--read and print out text data
  integer h ,totcol,w,columns_to_add,new_total,
          extra_space,largest,remain,spaces_per
  sequence collen
    w=papFontSize[1]
    h=papFontSize[2]--
   ----------------- get  maximum length for all columns----
    collen=repeat(0,length(data[1]))
    for x= 1 to length(data) do--rows
       for y=1 to length(data[1]) do
          if length(data[x][y])>collen[y] then
            collen[y]=length(data[x][y])
          end if
       end for
    end for
   --------------------calculate column info-----------
    totcol=3--the number first col
    largest=0
    for x=1 to length(data[1]) do--cols
      totcol=totcol+collen[x]
        if collen[x]>largest then
           largest=collen[x]
        end if
    end for
    setText(SB2,totcol)
   -------------------show column info-----------------
   columns_to_add=length(collen)+1--these are the spaces columns
  for x=1 to length(collen) do
     setPenPos(PrWin,640,x*h*2)
       wPuts(PrWin,sprintf("%d %d",{x,collen[x]}))
  end for
     setTextColor(PrWin,Yellow)
     setPenPos(PrWin,640,9*h*2)
        wPuts(PrWin,sprintf("Length printer line=%d",{charsPerLine}))
     setPenPos(PrWin,640,10*h*2)
        wPuts(PrWin,sprintf("Text to add=%d",{totcol}))
     setPenPos(PrWin,640,11*h*2)
        remain=charsPerLine-totcol
        wPuts(PrWin,sprintf("Remainder=%d",{remain}))
     setPenPos(PrWin,640,13*h*2)
        wPuts(PrWin,sprintf("Num Blank Cols=%d",{columns_to_add}))
     setPenPos(PrWin,640,14*h*2)
        spaces_per=floor(remain/columns_to_add)
        wPuts(PrWin,sprintf("Num Spaced Per Col=%d",{spaces_per}))
     setPenPos(PrWin,640,16*h*2)
        new_total=totcol + spaces_per * columns_to_add
         wPuts(PrWin,sprintf("NewTotal =%d",{new_total}))
     setPenPos(PrWin,640,17*h*2)
         extra_space=charsPerLine-new_total
          wPuts(PrWin,sprintf("Extra_spaces=%d",{ extra_space}))
  return largest & w & h & spaces_per & {collen}
end function
 
         --------pad and print data--------
procedure print_out(integer where,integer w,integer h,sequence data,
                    integer spaces_per,integer largest,
                    sequence collen)
   sequence line,item
  setPenPos(where,82*w,h)
    wPuts(where,getdate())
 for x=1 to length(data) do--number of rows
     setPenPos(where,1,x*h-h+3*h)
    line=sprintf("%3d",x)&repeat(' ',spaces_per)
      for y =1 to length(data[1]) do
       item=data[x][y]&repeat(' ',largest*2)
       line=line&item[1..collen[y]]&repeat(' ',spaces_per)
     end for
  wPuts(where,line)
 end for
end procedure
         --------pad and print data--------
procedure print_out_text(integer where,integer w,integer h,sequence data)
   sequence line,item
  setPenPos(where,82*w,h)
    wPuts(where,getdate())
 for x=1 to length(data) do--number of rows
     setPenPos(where,1,x*h-h+3*h)
   -- line=sprintf("%3d",x)&repeat(' ',spaces_per)
     -- for y =1 to length(data[1]) do
     --  item=data[x][y]&repeat(' ',largest*2)
     --  line=line&item[1..collen[y]]&repeat(' ',spaces_per)
    -- end for
  wPuts(where,data[x])
 end for
end procedure

procedure myclose(integer a,integer b,sequence c)
  closeWindow(paper)
  closeWindow(PrWin)
end procedure

  -----------------------< Main Program >----------------------
global procedure print_columns(sequence data)
  integer largest,h,w,spaces_per,answer,prtFontH,prtFontW
  object junk,stuff
  sequence collen
 -- openWindow(PrWin,0)-- print preview window
  stuff=get_printer_info()
if sequence(stuff) then
    drawPaper(stuff[1],stuff[2])
    prtFontH=stuff[5]
    prtFontW=stuff[4]
    openWindow(paper,0)
    get_info2()
    stuff=read_text(data)
    largest=stuff[1]
    w=stuff[2]
    h=stuff[3]
    spaces_per=stuff[4]
    collen=stuff[5]
     print_out(paper,w,h,data,spaces_per,largest,collen)
     answer = message_box("Print", "Messagebox[printer.e]", {MB_YESNO, MB_ICONQUESTION})
  --   answer=IDYES
     if answer = IDYES then --print it
          if startDoc( "My Print Job" ) then-- start up the document
          end if
         junk = startPage()  -- top of page
        print_out(Printer,prtFontW,prtFontH,data,spaces_per,largest,collen)
          junk=endPage()-- then, finally, send the page to the printer
        if endDoc() then
          releasePrinter()
        end if
     elsif answer = IDNO then --don't print it
       closeWindow(paper)
        closeWindow(PrWin)
        setFocus(Window1)
     --  WinMain( Window1,Maximize )
     end if
end if
end procedure

global procedure print_text(sequence data)
  integer largest,h,w,spaces_per,answer,prtFontH,prtFontW
  object junk,stuff
  sequence collen
 -- openWindow(PrWin,0)-- print preview window
  stuff=get_printer_info()
if sequence(stuff) then
    drawPaper(stuff[1],stuff[2])
    prtFontH=stuff[5]
    prtFontW=stuff[4]
    openWindow(paper,0)
    get_info2()
   -- stuff=read_text(data)
   -- largest=stuff[1]
  --  w=stuff[2]
  --  h=stuff[3]
   -- spaces_per=stuff[4]
  --  collen=stuff[5]
    -- print_out(paper,w,h,data,spaces_per,largest,collen)
      
       answer = message_box("Print", "messagebox2 demo", {MB_YESNO, MB_ICONQUESTION})
     if answer = IDYES then --print it
          if startDoc( "My Print Job" ) then-- start up the document
          end if
         junk = startPage()  -- top of page
        print_out_text(Printer,prtFontW,prtFontH,data)
          junk=endPage()-- then, finally, send the page to the printer
        if endDoc() then
          releasePrinter()
        end if
     elsif answer = IDNO then --don't print it
       closeWindow(paper)
        closeWindow(PrWin)
        setFocus(Window1)
     --  WinMain( Window1,Maximize )
     end if
end if
end procedure
 
--onClick[PushButton6]=routine_id("myclose")
setHandler(PushButton6,w32HClick,routine_id("myclose"))

